#include "mgn.h"

XYZ ll_to_xyz(LL ll)
{
XYZ xyz;

extern double cos(double);
extern double sin(double);

xyz.x=cos(ll.lon*THST)*cos(ll.lat*THST);
xyz.y=sin(ll.lon*THST)*cos(ll.lat*THST);
xyz.z=sin(ll.lat*THST);

return(xyz);
}

LL xyz_to_ll(XYZ xyz)
{
LL ll;
float sq;
extern double atan2(double,double);
extern double sqrt(double);

sq=xyz.x*xyz.x;
sq+=xyz.y*xyz.y;
sq=sqrt(sq);

ll.lon=atan2(xyz.y,xyz.x)/THST;
ll.lat=atan2(xyz.z,sq)/THST;

return(ll);

}

GCPath make_gcpath(LL l1,LL l2)
{
GCPath ret;

ret.start=ll_to_xyz(l1);
ret.delta=ll_to_xyz(l2);

ret.delta.x-=ret.start.x;
ret.delta.y-=ret.start.y;
ret.delta.z-=ret.start.z;

return(ret);
}

LL get_point_on_gcpath(GCPath p,float l)
{
XYZ x;

x=p.start;
x.x+=l*p.delta.x;
x.y+=l*p.delta.y;
x.z+=l*p.delta.z;

return(xyz_to_ll(x));
}


