/*
 * $Log: altcontor.c,v $
 * Revision 14.0  1998/07/31 19:46:47  root
 * \#makecheckin
 *
 * Revision 13.0  1998/07/31 19:46:30  root
 * \#makecheckin
 *
 * Revision 12.0  1998/07/31 09:58:26  root
 * \#makecheckin
 *
 * Revision 11.0  1998/05/02 23:03:44  root
 * \#makecheckin
 *
 * Revision 10.0  1997/10/22 18:33:55  root
 * \#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 * Revision 5.1  1997/07/04 00:31:03  root
 * \#makecheckin
 *
 * Revision 5.0  1997/07/03 15:05:48  root
 * \#makecheckin
 *
 * Revision 4.0  1997/07/01 11:58:59  root
 * \#makecheckin
 *
 * Revision 3.0  1997/06/23 12:51:50  root
 * \#makecheckin
 *
 * Revision 2.0  1997/06/23 09:04:44  root
 * \#makecheckin
 *
 * Revision 1.9  1997/06/18 15:15:32  root
 * \#makecheckin
 *
 * Revision 1.8  1997/06/15 23:47:49  root
 * \#makecheckin
 *
 */

static char rcsid[] = "$Id: altcontor.c,v 14.0 1998/07/31 19:46:47 root Exp root $";

#include "mgn.h"


void
alt_repaint_contours (View v)
{
  float step, level;
  Altview_private *p = v->altview_private;
  float min, max;

  {
    float *pstep = (float *) xv_get (v->frame, XV_KEY_DATA, CONTOUR_STEP_KEY);
    float *plevel = (float *) xv_get (v->frame, XV_KEY_DATA, CONTOUR_LEVEL_KEY);

    step = *pstep;
    level = *plevel;

  }
  if (step == 0.0)
    return;

  if (!p->buffered)
    p->buffered = alt_make_value_tile (p->current);


  if (!p->buffered)
    return;


  fprintf (MOAN, "contor: level is %f step is %f\n", level, step);

  alt_find_range (p->current, &min, &max);

  min -= level;
  min = min / step;
  min = floor (min);
  min -= 0.5;
  min *= step;
  min += level;

  max -= level;
  max = max / step;
  max = ceil (max);
  max += 0.5;
  max *= step;
  max += level;

  view_set_color (v, MGN_GREEN);
  do_contour (v, p->buffered, level, 1);

  {
    float l;

    view_set_color (v, MGN_RED);

    for (l = level + step; l < max; l += step)
      {
        do_contour (v, p->buffered, l, 1);
      }


    view_set_color (v, MGN_BLUE);

    for (l = level - step; l > min; l -= step)
      {
        do_contour (v, p->buffered, l, 1);
      }


  }


}


static void
contour_step_notify (Menu m, Menu_item mi)
{
  View v = (View) xv_get (mi, XV_KEY_DATA, VIEW_KEY);
  float *step = (float *) xv_get (mi, XV_KEY_DATA, CONTOUR_STEP_KEY);
  float *current = (float *) xv_get (v->frame, XV_KEY_DATA, CONTOUR_STEP_KEY);

  *current = *step;

  xv_set (m, MENU_DEFAULT_ITEM, mi, 0);

  ext_view_repaint (v);

}

static void
contour_level_notify (Menu m, Menu_item mi)
{
  View v = (View) xv_get (mi, XV_KEY_DATA, VIEW_KEY);
  float *level = (float *) xv_get (mi, XV_KEY_DATA, CONTOUR_LEVEL_KEY);
  float *current = (float *) xv_get (v->frame, XV_KEY_DATA, CONTOUR_LEVEL_KEY);

  if (*level > 4000.0)
    {
      *current = *level;
    }
  else
    {
      (*current) += *level;
    }

  xv_set (m, MENU_DEFAULT_ITEM, mi, 0);

  ext_view_repaint (v);

}

static void
contour_set_level_notify (Menu m, Menu_item mi)
{
  View v = (View) xv_get (mi, XV_KEY_DATA, VIEW_KEY);
  float *level = (float *) xv_get (v->frame, XV_KEY_DATA, CONTOUR_LEVEL_KEY);
  Alttile t = v->altview_private->current;

  IXY pos;
  LL ll;

  float rad;

  if (!t)
    return;

  pos = v->menu_pos;
  ll = ixy_to_ll (v, pos);
  alt_find_nearest_in_tile (t, ll, &pos);

  rad = t->data[pos.x][pos.y].rad;

  if (rad != 0.0)
    {
      *level = rad;
      ext_view_repaint (v);
    }
}

static void
contour_step_menu (View v, Menu base)
{
  Menu m;
  char buf[80];
  int d, b, i;
  float *step = malloc (sizeof (float));
  Menu_item mi;
  int otf[] =
  {
    1, 2, 5
  };

  *step = 0.0;

  m = xv_create (0, MENU,
                 MGN_PIN (v, "Contor step")
                 0);

  {
    float *val = malloc (sizeof (float));
    *val = 0.0;

    mi = xv_create (0, MENUITEM,
                    MENU_STRING, "Off",
                    MENU_NOTIFY_PROC, contour_step_notify,
                    XV_KEY_DATA, CONTOUR_STEP_KEY, val,
                    XV_KEY_DATA, VIEW_KEY, v,
                    0);

    xv_set (m, MENU_APPEND_ITEM, mi, 0);
    xv_set (m, MENU_DEFAULT_ITEM, mi, 0);
  }



  b = 1;
  for (d = 0; d < 3; ++d)
    {
      for (i = 0; i < 3; ++i)
        {
          float *val = malloc (sizeof (float));

          *val = (float) b;
          *val *= (float) otf[i];
          *val *= 0.01;

          sprintf (buf, "%.2f km", *val);

          mi = xv_create (0, MENUITEM,
                          MENU_STRING, strdup (buf),
                          MENU_RELEASE,
                          MENU_NOTIFY_PROC, contour_step_notify,
                          XV_KEY_DATA, CONTOUR_STEP_KEY, val,
                          XV_KEY_DATA, VIEW_KEY, v,
                          0);

          xv_set (m, MENU_APPEND_ITEM, mi, 0);



        }

      b *= 10;
    }

  xv_set (base, MENU_PULLRIGHT_ITEM, "Step", m, 0);
  xv_set (v->frame, XV_KEY_DATA, CONTOUR_STEP_KEY, step, 0);
}


static void
contour_level_menu (View v, Menu base)
{
  Menu m;
  char buf[80];
  float *level = malloc (sizeof (float));
  float l;
  int d, b, i;
  int otf[] =
  {
    1, 2, 5
  };
  Menu_item mi;

  *level = 6052.0;

  m = xv_create (0, MENU,
                 MGN_PIN (v, "Contor level")
                 0);

  for (l = 6046.0; l < 6059.1; l += 1.0)
    {
      float *val = malloc (sizeof (float));

      *val = l;
      sprintf (buf, "%.2f km", *val);

      mi = xv_create (0, MENUITEM,
                      MENU_STRING, strdup (buf),
                      MENU_RELEASE,
                      MENU_NOTIFY_PROC, contour_level_notify,
                      XV_KEY_DATA, CONTOUR_LEVEL_KEY, val,
                      XV_KEY_DATA, VIEW_KEY, v,
                      0);

      xv_set (m, MENU_APPEND_ITEM, mi, 0);

    }




  b = 1;
  for (d = 0; d < 1; ++d)
    {
      for (i = 0; i < 3; ++i)
        {
          float *val = malloc (sizeof (float));

          *val = (float) b;
          *val *= (float) otf[i];
          *val *= 0.1;

          sprintf (buf, "+%.2f km", *val);

          mi = xv_create (0, MENUITEM,
                          MENU_STRING, strdup (buf),
                          MENU_RELEASE,
                          MENU_NOTIFY_PROC, contour_level_notify,
                          XV_KEY_DATA, CONTOUR_LEVEL_KEY, val,
                          XV_KEY_DATA, VIEW_KEY, v,
                          0);

          xv_set (m, MENU_APPEND_ITEM, mi, 0);



        }

      b *= 10;
    }


  b = 1;
  for (d = 0; d < 1; ++d)
    {
      for (i = 0; i < 3; ++i)
        {
          float *val = malloc (sizeof (float));

          *val = (float) -b;
          *val *= (float) otf[i];
          *val *= 0.1;

          sprintf (buf, "%.2f km", *val);

          mi = xv_create (0, MENUITEM,
                          MENU_STRING, strdup (buf),
                          MENU_RELEASE,
                          MENU_NOTIFY_PROC, contour_level_notify,
                          XV_KEY_DATA, CONTOUR_LEVEL_KEY, val,
                          XV_KEY_DATA, VIEW_KEY, v,
                          0);

          xv_set (m, MENU_APPEND_ITEM, mi, 0);



        }

      b *= 10;
    }


  xv_set (base, MENU_PULLRIGHT_ITEM, "level", m, 0);
  xv_set (v->frame, XV_KEY_DATA, CONTOUR_LEVEL_KEY, level, 0);
}

void
alt_contour_menu (View v, Menu base)
{
  Menu_item mi;
  Menu m, bm;

  m = xv_create (0, MENU,
                 MGN_PIN (v, "Contoring")
                 0);


  contour_step_menu (v, m);
  contour_level_menu (v, m);

  mi = xv_create (0, MENUITEM,
                  MENU_STRING, "Set Level",
                  MENU_NOTIFY_PROC, contour_set_level_notify,
                  XV_KEY_DATA, VIEW_KEY, v,
                  0);

  xv_set (m, MENU_APPEND_ITEM, mi, 0);


  xv_set (base, MENU_PULLRIGHT_ITEM, "Contouring", m, 0);


}
