

/*
 * $Log: altimetry.c,v $
 * Revision 14.0  1998/07/31 19:46:47  root
 * \#makecheckin
 *
 * Revision 13.0  1998/07/31 19:46:30  root
 * \#makecheckin
 *
 * Revision 12.0  1998/07/31 09:58:26  root
 * \#makecheckin
 *
 * Revision 11.0  1998/05/02 23:03:44  root
 * \#makecheckin
 *
 * Revision 10.1  1997/10/22 18:35:49  root
 * \#makecheckin
 *
 * Revision 10.0  1997/10/22 18:33:55  root
 * \#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 * Revision 5.0  1997/07/03 15:05:48  root
 * \#makecheckin
 *
 * Revision 4.0  1997/07/01 11:58:59  root
 * \#makecheckin
 *
 * Revision 3.1  1997/07/01 11:58:46  root
 * \#makecheckin
 *
 * Revision 3.0  1997/06/23 12:51:50  root
 * \#makecheckin
 *
 * Revision 2.0  1997/06/23 09:04:44  root
 * \#makecheckin
 *
 * Revision 1.12  1997/06/18 22:11:09  root
 * \#makecheckin
 *
 * Revision 1.11  1997/06/18 15:15:32  root
 * \#makecheckin
 *
 * Revision 1.10  1997/06/15 23:47:48  root
 * \#makecheckin
 *
 */

static char rcsid[] = "$Id: altimetry.c,v 14.0 1998/07/31 19:46:47 root Exp root $";

#include "mgn.h"

#define ARCDR_CACHE_SIZE 20
static Arcdr_list arcdr_cache = NULL;
static int serial = 0;

/* Various possibles data can be in VAX or IEEE */
/* and we can be on a big or little endian machine */


static
ar_rec_convert (int f, ar_rec * rec)
{
  switch (f)
    {
    case ALT_VAX:

      BO_I_VTOM (&rec->ar_nfoot, 3);
      BO_I_VTOM (&rec->ar_looks, 2);
      BO_I_VTOM (&rec->ar_rslooks, 2);
      BO_I_VTOM (&rec->ar_thresh, 8);

      BO_D_VTOM (&rec->ar_scet, 7);
      BO_F_VTOM (&rec->ar_lon, 43);
      BO_F_VTOM (&rec->ar_rsfit, 2);
      BO_F_VTOM (&rec->ar_rhofact, 3);

      break;
    case ALT_IEEE:
      fprintf (MOAN, "alt: ar_rec_convert using untested IEEE conversion code\n");

      BO_I_ITOM (&rec->ar_nfoot, 3);
      BO_I_ITOM (&rec->ar_looks, 2);
      BO_I_ITOM (&rec->ar_rslooks, 2);
      BO_I_ITOM (&rec->ar_thresh, 8);

      BO_D_ITOM (&rec->ar_scet, 7);
      BO_F_ITOM (&rec->ar_lon, 43);
      BO_F_ITOM (&rec->ar_rsfit, 2);
      BO_F_ITOM (&rec->ar_rhofact, 3);


      break;
    default:
      fprintf (MOAN, "alt: ar_rec_convert unknown format\n");
    }
}




void
arcdr_destructor (Arcdr a)
{
  if (a->cache)
    Obj_Delete (a->cache);
  if (a->file)
    fclose (a->file);
  if (a->path)
    free (a->path);
  free (a);
}



char *
alt_head_get_str (char *head, char *lbl)
{
  char *s, *f;

  s = malloc (strlen (lbl) + 2);
  strcpy (s, lbl);
  strcat (s, "=");

  f = strstr (head, s);

  if (!f)
    {
      free (s);
      return (NULL);
    }

  f += strlen (s);

  free (s);

  f = strdup (f);
  s = index (f, '\r');
  if (!s)
    return (f);
  *s = 0;
  s = strdup (f);
  free (f);

  return (s);

}

int
alt_head_get_int (char *head, char *lbl, int *r)
{
  char *s, *f;

  s = malloc (strlen (lbl) + 2);
  strcpy (s, lbl);
  strcat (s, "=");

  f = strstr (head, s);

  if (!f)
    {
      free (s);
      return (0);
    }

  f += strlen (s);

  *r = atoi (f);

  return (1);


}


int
read_sfdu (FILE * f, sfdu * s)
{
  char buf[10];

  bzero (s, sizeof (sfdu));

  fread (s, sizeof (sfdu), 1, f);

  if ((strncmp (s->sf_ctrl, SFDU_CCSD, 4) != 0) &&
      (strncmp (s->sf_ctrl, SFDU_NJPL, 4) != 0))
    return (0);

  bcopy (s->sf_length.sf_clen, buf, 8);
  buf[8] = 0;

  return (atoi (buf));
}


int
read_arcdr_and_update (Arcdr a, ar_rec * r)
{
  sfdu s;
  int l;
  int ptr;

  ptr = ftell (a->file);
  l = read_sfdu (a->file, &s);

  if (!l)
    return (0);

  while (strncmp (s.sf_ddid, MGM_ADF_DDID, 4) != 0)
    {
      fseek (a->file, l, SEEK_CUR);

      ptr = ftell (a->file);
      l = read_sfdu (a->file, &s);
      if (!l)
        return (0);
    }

  r->ar_sfdu = s;
  fread (&r->ar_nfoot, sizeof (ar_rec) - sizeof (sfdu), 1, a->file);
  ar_rec_convert (a->format, r);


  if (r->ar_nfoot > a->cache_wakeup_foot)
    {
      Arcache_ent ce = CREATE_OBJ (Arcache_ent);

      a->cache_wakeup_foot = r->ar_nfoot + AR_CACHE_GRANULARITY;

      ce->foot = r->ar_nfoot;
      ce->pos = ptr;
      Obj_Insert (a->cache, ce, ObjInsertTail);



    }




  a->current = r->ar_nfoot;
  a->ptr = ptr;

  return (1);
}



Arcdr
open_arcdr (char *path)
{
  Arcdr a;
  sfdu s;

  FILE *file = vfs_fopen (path, "altimetry", "r");

  if (!file)
    return (NULL);

  a = CREATE_OBJ (Arcdr);

  a->cache = CREATE_LIST (Arcache_ent);
  a->cache_wakeup_foot = -10000;

  a->path = strdup (path);
  a->file = file;

  a->head_len = read_sfdu (file, &s);

  if (!a->head_len)
    {
      fprintf (MOAN, "arcdr: cannot understand SFDU header in %s\n", a->path);
      Obj_Delete (a);
      return (NULL);
    }


  if ((a->head_len > 4096) || (a->head_len <= 0))
    {
      fprintf (MOAN, "arcdr: preposterous header length in %s\n", a->path);
      Obj_Delete (a);
      return (NULL);
    }

  a->header = malloc (a->head_len + 1);
  fread (a->header, 1, a->head_len, file);
  a->header[a->head_len] = 0;

  {
    char *f;

    f = alt_head_get_str (a->header, "DATA_FORMAT_TYPE");

    if (f)
      {

        if (strncmp (f, "IEEE", 4) == 0)
          {
            a->format = ALT_IEEE;
          }
        else if (strncmp (f, "VAX", 3) == 0)
          {
            a->format = ALT_VAX;
          }
        else
          {
            free (f);
            f = NULL;
          }
      }

    if (!f)
      {
        fprintf (MOAN, "arcdr: cannot determine format of %s\n", a->path);
        Obj_Delete (a);
        return (NULL);
      }


    free (f);
  }

  if (!alt_head_get_int (a->header, "ORBIT_NUMBER", &a->orbit))
    {
      fprintf (MOAN, "arcdr: cannot determine prbit # of %s\n", a->path);
      Obj_Delete (a);
      return (NULL);
    }



  a->start = ftell (a->file);

  {
    ar_rec r;
    int f = read_arcdr_and_update (a, &r);

    if (!f)
      {
        fprintf (MOAN, "arcdr: can't find first footprint in %s\n",
                 a->path, f);
        Obj_Delete (a);
        return (NULL);
      }


    fprintf (MOAN, "arcdr: %s has first footprint %d\n",
             a->path, r.ar_nfoot);

  }

  a->sfoot = a->current;

  return (a);
}

int
arcdr_read (Arcdr a, ar_rec * d)
{
  return (read_arcdr_and_update (a, d));
}


int
arcdr_read_foot (Arcdr a, int f, ar_rec * d)
{
  Arcache_ent use = NULL, ce;


/* Asked for the same again? */
  if (f == a->current)
    {
      fseek (a->file, a->ptr, SEEK_SET);
      return (read_arcdr_and_update (a, d));
    }

/* Use the cache */

#if 0

  if (f < a->current)
    {
      fseek (a->file, a->start, SEEK_SET);
      a->current = -10000;
    }

  while (a->current < f)
    if (!read_arcdr_and_update (a, d))
      return (0);



  if (a->current != f)
    {
      bzero (d, sizeof (ar_rec));
      return (0);
    }
#endif


  ce = a->cache->head;

  while (ce)
    {
      if (ce->foot < f)
        use = ce;
      ce = ce->next;
    }

  if (!use)
    {
      /* Before start */
      bzero (d, sizeof (ar_rec));
      return (0);
    }
  a->current = use->foot;
  a->ptr = use->pos;


/* Found nearest below, seek forwards */
  fseek (a->file, a->ptr, SEEK_SET);

  while (a->current < f)
    if (!read_arcdr_and_update (a, d))
      return (0);

  if (a->current != f)
    {
      bzero (d, sizeof (ar_rec));
      return (0);
    }


  return (1);

}

void
arcdr_rewind (Arcdr a)
{
  fseek (a->file, a->start, SEEK_SET);
  a->ptr = a->start;
  a->current = a->sfoot;

}

Arcdr
open_arcdr_by_orbit (int orbit)
{
  char buf[100];
  int ver;
  Arcdr a;

  for (ver = ARCDR_MAX_VER; ver > 0; ver--)
    {
      sprintf (buf, "adf%05d.%d", orbit, ver);
      a = open_arcdr (buf);
      if (a)
        return (a);
    }
  return (a);

}


Arcdr
get_arcdr_by_orbit (int orbit)
{
  char buf[100];

  Arcdr a;
  int n = 0;

  Arcdr least = NULL;
  int lowest = serial + 1;

  if (!arcdr_cache)
    arcdr_cache = CREATE_LIST (Arcdr);

  a = arcdr_cache->head;

  while (a)
    {

      if (a->orbit == orbit)
        {
          a->used = serial++;
          return (a);
        }

      if (a->used < lowest)
        {
          lowest = a->used;
          least = a;
        }
      n++;

      a = a->next;
    }


  if (n > ARCDR_CACHE_SIZE)
    {
      Obj_Remove (arcdr_cache, least);
      Obj_Delete (least);
    }

  a = open_arcdr_by_orbit (orbit);

  if (!a)
    return (a);

  a->used = serial++;
  Obj_Insert (arcdr_cache, a, ObjInsertHead);

  fprintf (MOAN, "arcdr: adding orbit %d to cache\n", a->orbit);

  return (a);

}




/* James's wacky orbit parameterization.. */
/* although the orbit is eliptical the projection onto the */
/* surface of the planet will be the same it only affects */
/* density of footprints */
/* All this code is required to do is given a jorb structure */
/* to give a qualatative distance to a given LL */
/* The orbit is parameterized by the longitude at which it crosses */
/* the plane of the equator (when mapping), and the angle between the */
/* the plane of the orbit and the plane of the equator */

static LL
t_to_ll (Jorb j, float t)
{
  LL ll;
  float f1, f2;

  f1 = cos (j.incl) * sin (t);

  f2 = cos (t);
  f2 = f2 * f2 + f1 * f1;
  f2 = sqrt (f2);

  f1 = sin (j.incl) * sin (t);

  ll.lat = atan2 (f1, f2) / THST;

  f1 = cos (t);
  f2 = cos (j.incl) * sin (t);

  ll.lon = atan2 (f1, f2) / THST;
  ll.lon -= 90;

  ll.lon += j.lon;

  return (ll);
}


static Jorb
work_out_jorb (Arcdr a)
{
  int l;
  float lat, lon;
  float t;

  ar_rec r;
  Jorb j =
  {0, 0, 0};

  arcdr_rewind (a);

  if (!read_arcdr_and_update (a, &r))
    return (j);

  lat = r.ar_lat;
  lon = r.ar_lon;


  while (r.ar_lat > 0.0)
    {
      l = read_arcdr_and_update (a, &r);
      if (!l)
        return (j);
    }


  if (r.ar_lat < -1.0)
    {
      fprintf (MOAN, "jorb: Footprint at equator (%f) is too far out (man)\n",
               r.ar_lat);
      return (j);
    }

  fprintf (MOAN, "jorb: Footprint at equator (%f) was %d\n",
           r.ar_lat, r.ar_nfoot);

  j.foot = r.ar_nfoot + ALT_FIDDLE_FOOT;
  j.lon = r.ar_lon;


  {
    float a, b, c;
    float f1, f2;

    b = lon;
    b -= j.lon;
    b += 90;

    a = tan (lat * THST);
    b = tan (b * THST);

    f1 = 1.0;
    f1 += a * a;
    f1 += a * a * b * b;

    f2 = 1.0 + a * a;
    f2 *= 1.0 + b * b;

    c = sqrt (f1 / f2);


    c *= sqrt ((b * b) / f2);

    f2 *= c / f1;

    t = atan (1.0 / f2);

    f2 = f2 / b;

    j.incl = acos (f2);

  }

/* A quick sanity check */
/*
   {
   LL ll;
   ll=t_to_ll(j,t);
   printf("alt: %f %f from %f %f\n%f\n",ll.lat,ll.lon,lat,lon,j.lon);
   }
 */

  return (j);


}


static float
jorb_dist (Jorb j, LL ll)
{
  float a, t;
  float f1, f2, f3, f4;
  LL orb;

  a = tan (ll.lat * THST);

  f4 = sin (j.incl);
  f4 *= f4;

  f3 = a * cos (j.incl);
  f3 *= f3;
  f1 = f4 - f3;

  f2 = a * a;

  f3 = a * cos (j.incl);
  f3 *= f3;

  f2 -= f3;
  f2 += f4;

  f1 = sqrt (f1 / f2);
  t = acos (f1);
  if (ll.lat < 0)
    t = (2 * PI - t);


  orb = t_to_ll (j, t);
  orb.lon -= ll.lon;

  while (orb.lon > 180.0)
    orb.lon -= 360.0;
  while (orb.lon < -180.0)
    orb.lon += 360.0;

/*
   if (orb.lon < 0.0)
   orb.lon = -orb.lon;
 */

  return (orb.lon);
}


static int jorb_library = 0;

static int
open_jorb ()
{

  char *path = mgn_getenv ("MGNVIEW");
  char buf[1024];

  if (jorb_library)
    return (1);


  if (!path)
    return (0);
  strcpy (buf, path);

  strcat (buf, "/jorb.lib");

  jorb_library = open (buf, O_RDWR);

  if (jorb_library < 0)
    {
      jorb_library = 0;
      fprintf (MOAN, "jorb: cannot open %s\n", buf);
      return (0);
    }
  return (1);

}



static Jorb
extract_jorb (int orbit)
{
  Jorb j =
  {0, 0, 0};
  off_t o;

  if (!jorb_library)
    {
      if (!open_jorb ())
        return (j);
    }

  o = sizeof (Jorb) * orbit;

  lseek (jorb_library, o, SEEK_SET);

  read (jorb_library, &j, sizeof (Jorb));

  BO_I_FTOM (&j.foot, 1);
  BO_F_FTOM (&j.lon, 2);


  return (j);
}

static int
inject_jorb (int orbit, Jorb j)
{
  off_t o;

  if (!jorb_library)
    {
      if (!open_jorb ())
        return (0);
    }

  o = sizeof (Jorb) * orbit;


  lseek (jorb_library, o, SEEK_SET);

  BO_I_MTOF (&j.foot, 1);
  BO_F_MTOF (&j.lon, 2);

  write (jorb_library, &j, sizeof (Jorb));

  return (1);
}

void
update_jorb (Arcdr a)
{
  Jorb j;

  if (!a)
    return;

  j = work_out_jorb (a);

  if (!j.foot)
    return;

  inject_jorb (a->orbit, j);

}

int
get_alt_filename (int orbit, char *buf)
{
  char b[1024];
  char *path = mgn_getenv ("MGNVIEW");

  sprintf (b, "%06d.nlt", orbit);

  if (!path)
    return (0);

  strcpy (buf, path);

  strcat (buf, "/altimetry/");
  strcat (buf, b);

  return (1);

}


update_alt_lib (Arcdr a)
{
  ar_rec r;
  alt_rec alt;
  int alt_fd;
  int n = 0;

  if (!a)
    return;

  update_jorb (a);

  arcdr_rewind (a);

  {
    char buf[1024];

    if (!get_alt_filename (a->orbit, buf))
      return;

    alt_fd = open (buf, O_CREAT | O_RDWR, 0666);
    if (alt_fd < 0)
      {
        fprintf (MOAN, "alt: can't open %s for writing\n", buf);
        return;
      }

  }


  while (read_arcdr_and_update (a, &r))
    {

      alt.pos.lat = r.ar_lat;
      alt.pos.lon = r.ar_lon;
      alt.rad = r.ar_radius;
      alt.flags = 0;

      lseek (alt_fd, ALT_OFFSET (r.ar_nfoot), SEEK_SET);

      BO_F_MTOF (&alt.pos.lat, 2);
      BO_F_MTOF (&alt.rad, 1);
      BO_I_MTOF (&alt.flags, 1);


      write (alt_fd, &alt, sizeof (alt_rec));
      n++;

    }

  close (alt_fd);
  fprintf (MOAN, "alt: %d records transfered\n", n);


}



int
orbit_to_cycle (int orbit)
{
  orbit -= FIRST_ORBIT;
  orbit = orbit / ORBITS_PER_CYCLE;
  orbit++;
  return (orbit);
}

int
cycle_to_sorbit (int cycle)
{
  cycle--;
  cycle *= ORBITS_PER_CYCLE;
  cycle += FIRST_ORBIT;
  return (cycle);
}

int
cycle_to_eorbit (int cycle)
{
  cycle *= ORBITS_PER_CYCLE;
  cycle--;
  cycle += FIRST_ORBIT;
  return (cycle);
}


static Jorb
adjust_orbit_number_to_find_jorb (int *o, int dir)
{
  Jorb j;
  int c = orbit_to_cycle (*o);

  j = extract_jorb (*o);

  while (!j.foot)
    {
      (*o) += dir;

      if (c != orbit_to_cycle (*o))
        return (j);

      j = extract_jorb (*o);
    }

  return (j);
}

/* Find the nearest orbit to ll in cycle cycle erring above 
 * if err +1 and below if err -1 */

static Jorb
hunt (int t, int b, int *m, int cycle_start, int cycle_end, int dir)
{
  Jorb jm;

  /* Pick a point the middle with care */
  if (t > b)
    {
      *m = (t + b) / 2;
    }
  else
    {
      *m = (t + ORBITS_PER_CYCLE + b) / 2;
      if ((*m) > cycle_end)
        *m -= ORBITS_PER_CYCLE;

    }

  /* Now see if it exists */
  jm = adjust_orbit_number_to_find_jorb (m, dir);

  if (dir > 0)
    {

      if (*m > cycle_end)
        {
          *m = cycle_start;
          jm = adjust_orbit_number_to_find_jorb (m, dir);
        }

    }
  else
    {

      if (*m < cycle_start)
        {
          *m = cycle_end;
          jm = adjust_orbit_number_to_find_jorb (m, dir);
        }

    }

  return (jm);

}

int
find_nearest_orbit_to (LL ll, int cycle, int err)
{
  int b, t, m;
  Jorb jb, jt, jm;
  float dt, db, dm;

  int cycle_start = cycle_to_sorbit (cycle);
  int cycle_end = cycle_to_eorbit (cycle);

  b = cycle_start;
  t = cycle_end;

  jb = adjust_orbit_number_to_find_jorb (&b, 1);
  jt = adjust_orbit_number_to_find_jorb (&t, -1);


  if ((!jt.foot) || (!jb.foot))
    {
      fprintf (MOAN, "alt: find_nearest_orbit_to can't find any jorbs for cycle %d\n", cycle);
      return (0);
    }


  {
    int nt, nb, s;


    /* First to a quick survey to get the right hemisphere */
    s = cycle_end - cycle_start;
    s = s >> 4;
    s++;


    dt = 1.0e20;
    db = -1.0e20;


    for (m = cycle_start; m <= cycle_end; m += s)
      {
        jm = adjust_orbit_number_to_find_jorb (&m, 1);
        dm = jorb_dist (jm, ll);

        if (m <= cycle_end)
          {

            if (dm >= 0.0)
              {
                if (dm < dt)
                  {
                    dt = dm;
                    t = m;
                  }
              }
            else
              {
                if (dm > db)
                  {
                    db = dm;
                    b = m;
                  }
              }
          }

      }

  }


  jb = adjust_orbit_number_to_find_jorb (&b, 1);
  jt = adjust_orbit_number_to_find_jorb (&t, -1);

  dt = jorb_dist (jt, ll);
  db = jorb_dist (jb, ll);

  while (t != b)
    {


      jm = hunt (t, b, &m, cycle_start, cycle_end, 1);

/* Check that it hasn't searched all the way to the upper marker */
      if (m == t)
        {
          /* If so try the other way */

          jm = hunt (t, b, &m, cycle_start, cycle_end, -1);
        }

/* Check that that didn't hit the lower marker */
      if (m == b)
        {
          /* If so we have to give up here */

          if (err > 0)
            return (t);
          else
            return (b);
        }

      dm = jorb_dist (jm, ll);

      if (dm >= 0.0)
        {
          t = m;
          dt = dm;
        }
      else
        {
          b = m;
          db = dm;
        }


    }

  return (t);
}
