/*
 * $Log: altview.c,v $
 * Revision 14.0  1998/07/31 19:46:47  root
 * \#makecheckin
 *
 * Revision 13.0  1998/07/31 19:46:30  root
 * \#makecheckin
 *
 * Revision 12.0  1998/07/31 09:58:26  root
 * \#makecheckin
 *
 * Revision 11.0  1998/05/02 23:03:44  root
 * \#makecheckin
 *
 * Revision 10.2  1998/04/24 20:58:37  root
 * \#makecheckin
 *
 * Revision 10.1  1997/10/22 18:35:49  root
 * \#makecheckin
 *
 * Revision 10.0  1997/10/22 18:33:55  root
 * \#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 * Revision 5.1  1997/07/04 00:31:03  root
 * \#makecheckin
 *
 * Revision 5.0  1997/07/03 15:05:48  root
 * \#makecheckin
 *
 * Revision 4.0  1997/07/01 11:58:59  root
 * \#makecheckin
 *
 * Revision 3.0  1997/06/23 12:51:50  root
 * \#makecheckin
 *
 * Revision 2.0  1997/06/23 09:04:44  root
 * \#makecheckin
 *
 * Revision 1.14  1997/06/23 08:53:04  root
 * \#makecheckin
 *
 * Revision 1.13  1997/06/18 22:11:10  root
 * \#makecheckin
 *
 * Revision 1.12  1997/06/18 15:15:32  root
 * \#makecheckin
 *
 * Revision 1.11  1997/06/15 23:47:49  root
 * \#makecheckin
 *
 */

static char rcsid[] = "$Id: altview.c,v 14.0 1998/07/31 19:46:47 root Exp root $";

#include "mgn.h"

Alttile
alt_get_tile (View v, int cycle)
{
  Alttile t = NULL;

  if (!cycle)
    return (t);

  t = v->altview_private->tiles->head;

  while (t)
    {
      if (t->cycle == cycle)
        return (t);

      t = t->next;
    }

  t = create_alttile_from_midr (v->midr, cycle, TILE_ONE_ORBIT);
  if (!t)
    return (t);

  Obj_Insert (v->altview_private->tiles, t, ObjInsertHead);

  return (t);

}

Alttile
alt_get_subtile_from_view (View v, Alttile m)
{
  Alttile t = NULL;
  IXY ixy, s, b;
  LL ll;
  extern int alttileserial;

  int i, j;

  if (!m)
    return (t);

  s.x = m->size.x + 1;
  s.y = m->size.y + 1;
  b.x = b.y = -1;

/* Roll through the coreners of the picture and get lls */
/* find the nearest feet prints and then extract */

  for (i = 0; i < 4; ++i)
    {

      ixy.x = ixy.y = 0;
      if (i & 1)
        ixy.x += v->wx;
      if (i & 2)
        ixy.y += v->wy;

      ll = ixy_to_ll (v, ixy);

      ixy.x = ixy.y = 0;

      alt_find_nearest_in_tile (m, ll, &ixy);

      if (ixy.x > b.x)
        b.x = ixy.x;
      if (ixy.x < s.x)
        s.x = ixy.x;
      if (ixy.y > b.y)
        b.y = ixy.y;
      if (ixy.y < s.y)
        s.y = ixy.y;

    }

  b.x++;
  s.x--;
  b.y++;
  s.y--;

  if (s.x < 0)
    s.x = 0;
  if (s.y < 0)
    s.y = 0;

  if (b.x >= m->size.x)
    b.x = m->size.x - 1;
  if (b.y >= m->size.y)
    b.y = m->size.y - 1;

  fprintf (MOAN, "alt: subtile is (%d,%d)-(%d,%d) of (%d,%d)\n",
           s.x, s.y, b.x, b.y, m->size.x - 1, m->size.y - 1);


  if (s.x > b.x)
    return (NULL);
  if (s.y > b.y)
    return (NULL);

  t = CREATE_OBJ (Alttile);

  t->funcs = m->funcs;

  /* Don't destroy this tile in the same way as it doesn't */
  /* Have any data of its own */
  t->destructor = alttile_ptr_destructor;


  t->size.x = b.x - s.x + 1;
  t->size.y = b.y - s.y + 1;


  /* KLUDGE but it will work for all current types */
  t->pos = m->funcs.ixy_to_iof (m, s);
  t->cycle = m->cycle;
  t->type = m->type;


  t->data = (alt_rec **) malloc (sizeof (alt_rec *) * t->size.x);

  j = 0;
  for (i = s.x; i <= b.x; ++i)
    {
      t->data[j++] = &m->data[i][s.y];
    }

  t->serial = alttileserial++;

  return (t);

}

static void
alt_tidy (View v)
{
  fprintf (MOAN, "alt: alt_tidy called\n");

}



static void
alt_repaint_markers (View v)
{
  int x, y;
  IXY *line, *ptr;
  LL ll;
  Alttile t;
  int n = 0;
  int markers = (int) xv_get (v->frame, XV_KEY_DATA, ALT_MARKERS_KEY);

  if (!markers)
    return;

  t = v->altview_private->current;

  line = malloc (sizeof (IXY) * t->size.y);

  view_set_color (v, MGN_GREEN);

  for (x = 0; x < t->size.x; ++x)
    {
      ptr = line;
      n = 0;

      for (y = 0; y < t->size.y; ++y)
        {
          ll = t->data[x][y].pos;
          if (t->data[x][y].rad > 0.0)
            {
              *(ptr++) = ll_to_ixy (v, ll);
              n++;
            }

        }
      if (n)
        {
          switch (v->mode)
            {
            case V_NORMAL:
              view_draw_boxes (v, line, 5, n);
              break;
            case V_BROWSING:
              view_draw_points (v, line, n);
              break;
            }
        }
    }

  free (line);

}

void
invalidate_altimetry_cache (View v)
{

  if (v->altview_private->current)
    {
      Obj_Delete (v->altview_private->current);
      v->altview_private->current = NULL;
    }
  if (v->altview_private->buffered)
    {
      Obj_Delete (v->altview_private->buffered);
      v->altview_private->buffered = NULL;
    }
}

Alttile 
alt_get_current_master_tile(View v)
{
  int cycle = (int) xv_get (v->frame, XV_KEY_DATA, ALT_CYCLE_KEY);
  return(alt_get_tile (v, cycle));
}

void
alt_repaint (View v)
{
  int cycle = (int) xv_get (v->frame, XV_KEY_DATA, ALT_CYCLE_KEY);
  int tidy = (int) xv_get (v->frame, XV_KEY_DATA, ALT_TIDY_KEY);
  float step;
  Alttile t;

  t = alt_get_tile (v, cycle);

  if (!v->altview_private->current)
    {
      if (!t)
        return;

      v->altview_private->current = alt_get_subtile_from_view (v, t);

      if (!v->altview_private->current)
        return;

      if (tidy)
        alt_tidy (v);

      if (!v->altview_private->current)
        return;

    }

  alt_repaint_markers (v);
  alt_repaint_contours (v);
  profile_repaint (v, t);




}




static void
alt_cycle_notify (Menu m, Menu_item mi)
{
  View v = (View) xv_get (mi, XV_KEY_DATA, VIEW_KEY);
  int cycle = (int) xv_get (mi, XV_KEY_DATA, ALT_CYCLE_KEY);

  xv_set (v->frame, XV_KEY_DATA, ALT_CYCLE_KEY, cycle, 0);
  xv_set (m, MENU_DEFAULT_ITEM, mi, 0);

  invalidate_altimetry_cache (v);

  ext_view_repaint (v);

}

static void
alt_cycle_menu (View v, Menu base)
{
  Menu_item mi;
  Menu m;
  int i;
  char buf[10];

  m = xv_create (0, MENU,
                 MGN_PIN (v, "Alt Cycle")
                 0);

  mi = xv_create (0, MENUITEM,
                  MENU_STRING, "Off",
                  MENU_NOTIFY_PROC, alt_cycle_notify,
                  XV_KEY_DATA, VIEW_KEY, v,
                  XV_KEY_DATA, ALT_CYCLE_KEY, 0,
                  0);

  xv_set (m, MENU_APPEND_ITEM, mi, 0);
  xv_set (v->frame, XV_KEY_DATA, ALT_CYCLE_KEY, 0, 0);
  xv_set (m, MENU_DEFAULT_ITEM, mi, 0);

  for (i = 1; i < 6; ++i)
    {

      sprintf (buf, "%d", i);


      mi = xv_create (0, MENUITEM,
                      MENU_STRING, strdup (buf),
                      MENU_RELEASE,
                      MENU_NOTIFY_PROC, alt_cycle_notify,
                      XV_KEY_DATA, VIEW_KEY, v,
                      XV_KEY_DATA, ALT_CYCLE_KEY, i,
                      0);
      xv_set (m, MENU_APPEND_ITEM, mi, 0);


    }


  xv_set (base, MENU_PULLRIGHT_ITEM, "Cycle", m, 0);

}

static void
alt_markers_notify (Menu m, Menu_item mi)
{
  View v = (View) xv_get (mi, XV_KEY_DATA, VIEW_KEY);
  int markers = (int) xv_get (mi, XV_KEY_DATA, ALT_MARKERS_KEY);

  xv_set (v->frame, XV_KEY_DATA, ALT_MARKERS_KEY, markers, 0);
  xv_set (m, MENU_DEFAULT_ITEM, mi, 0);

  ext_view_repaint (v);

}

static void
contour_step_notify (Menu m, Menu_item mi)
{
  View v = (View) xv_get (mi, XV_KEY_DATA, VIEW_KEY);
  int markers = (int) xv_get (mi, XV_KEY_DATA, ALT_MARKERS_KEY);

  xv_set (v->frame, XV_KEY_DATA, ALT_MARKERS_KEY, markers, 0);
  xv_set (m, MENU_DEFAULT_ITEM, mi, 0);

  ext_view_repaint (v);

}

static void
alt_tidy_notify (Menu m, Menu_item mi)
{
  View v = (View) xv_get (mi, XV_KEY_DATA, VIEW_KEY);
  int tidy = (int) xv_get (mi, XV_KEY_DATA, ALT_TIDY_KEY);

  xv_set (v->frame, XV_KEY_DATA, ALT_TIDY_KEY, tidy, 0);
  xv_set (m, MENU_DEFAULT_ITEM, mi, 0);

  invalidate_altimetry_cache (v);

  ext_view_repaint (v);

}

static void
alt_tidy_menu (View v, Menu base)
{
  Menu_item mi;
  Menu m;

  m = xv_create (0, MENU,
                 MGN_PIN (v, "Alt Tidy")
                 0);

  mi = xv_create (0, MENUITEM,
                  MENU_STRING, "Off",
                  MENU_NOTIFY_PROC, alt_tidy_notify,
                  XV_KEY_DATA, VIEW_KEY, v,
                  XV_KEY_DATA, ALT_TIDY_KEY, 0,
                  0);
  xv_set (m, MENU_APPEND_ITEM, mi, 0);
  mi = xv_create (0, MENUITEM,
                  MENU_STRING, "On",
                  MENU_NOTIFY_PROC, alt_tidy_notify,
                  XV_KEY_DATA, VIEW_KEY, v,
                  XV_KEY_DATA, ALT_TIDY_KEY, 1,
                  0);
  xv_set (m, MENU_APPEND_ITEM, mi, 0);

  xv_set (base, MENU_PULLRIGHT_ITEM, "Tidy", m, 0);
  xv_set (v->frame, XV_KEY_DATA, ALT_TIDY_KEY, 0, 0);

}



static void
alt_markers_menu (View v, Menu base)
{
  Menu_item mi;
  Menu m;

  m = xv_create (0, MENU,
                 MGN_PIN (v, "Alt Markers")
                 0);

  mi = xv_create (0, MENUITEM,
                  MENU_STRING, "Off",
                  MENU_NOTIFY_PROC, alt_markers_notify,
                  XV_KEY_DATA, VIEW_KEY, v,
                  XV_KEY_DATA, ALT_MARKERS_KEY, 0,
                  0);
  xv_set (m, MENU_APPEND_ITEM, mi, 0);
  mi = xv_create (0, MENUITEM,
                  MENU_STRING, "On",
                  MENU_NOTIFY_PROC, alt_markers_notify,
                  XV_KEY_DATA, VIEW_KEY, v,
                  XV_KEY_DATA, ALT_MARKERS_KEY, 1,
                  0);
  xv_set (m, MENU_APPEND_ITEM, mi, 0);

  xv_set (base, MENU_PULLRIGHT_ITEM, "Markers", m, 0);
  xv_set (v->frame, XV_KEY_DATA, ALT_MARKERS_KEY, 0, 0);

}

void
alt_base_menu (View v)
{
  Menu m;
  char buf[80];
  int d, b, i;
  float *grid = malloc (sizeof (float));
  Menu_item mi;

  *grid = 0.0;

  m = xv_create (0, MENU,
                 MGN_PIN (v, "Altimetry")
                 0);

  alt_cycle_menu (v, m);
  alt_tidy_menu (v, m);
  alt_markers_menu (v, m);
  alt_contour_menu (v, m);

  mi = xv_create (0, MENUITEM,
                  MENU_STRING, "Return",
                  MENU_NOTIFY_PROC, return_notify,
                  XV_KEY_DATA, VIEW_KEY, v,
                  0);

  xv_set (m, MENU_APPEND_ITEM, mi, 0);

  profile_add_menu (v, m);


  xv_set (v->menu, MENU_PULLRIGHT_ITEM, "Altimetry", m, 0);
}
