/*
 *$Log: image.h,v $
 *Revision 14.0  1998/07/31 19:46:47  root
 *\#makecheckin
 *
 *Revision 13.0  1998/07/31 19:46:30  root
 *\#makecheckin
 *
 *Revision 12.0  1998/07/31 09:58:26  root
 *\#makecheckin
 *
 *Revision 11.0  1998/05/02 23:03:44  root
 *\#makecheckin
 *
 *Revision 10.0  1997/10/22 18:33:55  root
 *\#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 *Revision 5.0  1997/07/03 15:05:48  root
 *\#makecheckin
 *
 *Revision 4.0  1997/07/01 11:58:59  root
 *\#makecheckin
 *
 *Revision 3.0  1997/06/23 12:51:50  root
 *\#makecheckin
 *
 *Revision 2.0  1997/06/23 09:04:44  root
 *\#makecheckin
 *
 *Revision 1.5  1997/06/18 22:11:10  root
 *\#makecheckin
 *
 *Revision 1.4  1997/06/18 21:30:34  root
 *\#makecheckin
 *
 * Revision 1.3  1997/06/15  23:47:49  root
 * \#makecheckin
 *
 */


typedef struct {
  XImage *ximage;
  XShmSegmentInfo shm;
  Display *display;
} mgn_npshximage;

typedef struct {
  XImage *ximage;
  Pixmap pixmap;
  XShmSegmentInfo shm;
  Display *display;
} mgn_shximage;

typedef struct {
  XImage *ximage;
} mgn_ximage;

typedef struct {
  int dummy;
} mgn_memimage;

struct Image_struct;

struct image_funcs {
  void (*copyarea_to_x) (struct Image_struct *,
		    Display *, Window, GC, int, int, int, int, int, int);
};

#define MGN_NO_IMAGE 	0
#define MGN_SHXIMAGE 	1
#define MGN_XIMAGE 	2
#define MGN_MEMIMAGE 	3
#define MGN_NPSHXIMAGE	4

BEGIN_OBJECT(Image)
int type;

union {
  mgn_ximage x;
  mgn_shximage shx;
  mgn_npshximage npshx;
  mgn_memimage m;
} p;

uchar *data;
int bytesperline;
int x, y;
struct image_funcs funcs;
END_OBJECT(Image)
extern void image_destructor(Image);

CREATOR(Image) = Obj_DefaultCreator;
DESTRUCTOR(Image) = image_destructor;


typedef struct {
  int type;
  int x, y;
  union {
    struct {
      Display *display;
    } x;
    struct {
      Display *display;
      Window window;
    } shx;
    struct {
      Display *display;
    } npshx;
    struct {
      int dummy;
    } m;
  } p;
} Create_image_args;
