/*
 * $Log: info.c,v $
 * Revision 14.0  1998/07/31 19:46:47  root
 * \#makecheckin
 *
 * Revision 13.0  1998/07/31 19:46:30  root
 * \#makecheckin
 *
 * Revision 12.0  1998/07/31 09:58:26  root
 * \#makecheckin
 *
 * Revision 11.0  1998/05/02 23:03:44  root
 * \#makecheckin
 *
 * Revision 10.1  1997/10/22 18:35:50  root
 * \#makecheckin
 *
 * Revision 10.0  1997/10/22 18:33:55  root
 * \#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 * Revision 5.0  1997/07/03 15:05:48  root
 * \#makecheckin
 *
 * Revision 4.0  1997/07/01 11:58:59  root
 * \#makecheckin
 *
 * Revision 3.0  1997/06/23 12:51:50  root
 * \#makecheckin
 *
 * Revision 2.1  1997/06/23 09:25:57  root
 * *** empty log message ***
 *
 * Revision 2.0  1997/06/23 09:04:44  root
 * \#makecheckin
 *
 * Revision 1.7  1997/06/23 09:04:07  root
 * \#makecheckin
 *
 * Revision 1.6  1997/06/23 08:53:04  root
 * \#makecheckin
 *
 * Revision 1.5  1997/06/18 15:15:32  root
 * \#makecheckin
 *
 * Revision 1.4  1997/06/15 23:47:49  root
 * \#makecheckin
 *
 */

static char rcsid[] = "$Id: info.c,v 14.0 1998/07/31 19:46:47 root Exp root $";

#include "mgn.h"

#define INFO_WIDTH 400

static void
info_version (View v, char *buf)
{
  strcpy (buf, rcsid);
}

struct info_struct
{
  int x;
  int y;
  char *name;
  int len;
  void (*find_out) (View, char *);
}
infos[] =
{
  {
    0, 30, "Midr name", 15, info_midr_name
  }
  ,
  {
    300, 30, "Path", 20, info_midr_path
  }
  ,
  {
    0, 60, "Alt tile", 52, info_alttile
  }
  ,
  {
    0, 90, "Grid size", 15, info_grid_step
  }
  ,
  {
    0, 120, "Contor level", 20, info_contor_level
  }
  ,
  {
    300, 120, "Step", 20, info_contor_step
  }
  ,
  {
    0, 150, "Center of image at", 30, info_at
  }
  ,
  {
    0, 180, "Library version:", 45, info_version
  }
};

#define NUM_INFOS (sizeof(infos)/sizeof(struct info_struct))


void
info_repaint (View v)
{
  Info_private *p = v->info_private;
  char buf[1024];
  int i;

  if (!p)
    return;

  if (!p->on)
    return;

  for (i = 0; i < NUM_INFOS; ++i)
    {
      strcpy (buf, "The moon is made of cheese");

      infos[i].find_out (v, buf);

      xv_set (p->items[i],
              PANEL_VALUE, buf,
              0);
    }


}

static void
dismiss_notify (Panel_item i)
{
  View v = (View) xv_get (i, XV_KEY_DATA, VIEW_KEY);
  Info_private *p = v->info_private;

  if (!p)
    return;

  xv_set (p->frame, XV_SHOW, FALSE, 0);
  p->on = 0;


}


static void
info_notify (Menu m, Menu_item mi)
{
  float *val = (float *) xv_get (mi, XV_KEY_DATA, GRID_KEY);
  View v = (View) xv_get (mi, XV_KEY_DATA, VIEW_KEY);
  Info_private *p = v->info_private;

  if (!p)
    return;

  xv_set (p->frame, XV_SHOW, TRUE, 0);
  p->on = 1;

  ext_view_repaint (v);

}

void
info_base_menu (View v)
{

  Menu_item mi;


  mi = xv_create (0, MENUITEM,
                  MENU_STRING, "Info",
                  MENU_NOTIFY_PROC, info_notify,
                  XV_KEY_DATA, VIEW_KEY, v,
                  0);


  xv_set (v->menu, MENU_APPEND_ITEM, mi, 0);



}

void
info_private_destructor (View v)
{
  if (v->info_private)
    {

      free (v->info_private->items);
      free (v->info_private);
      v->info_private = NULL;

    }

}

void
info_private_init (View v)
{
  Info_private *p;

  p = v->info_private = (Info_private *) malloc (sizeof (Info_private));

  p->frame = xv_create (v->frame, FRAME,
                        XV_WIDTH, INFO_WIDTH,
                        FRAME_SHOW_LABEL, FALSE,
                        WIN_CMS, v->ctrl_cms,
                        XV_SHOW, FALSE,
                        0);


  p->panel = xv_create (p->frame, PANEL,
                        XV_WIDTH, INFO_WIDTH,
                        WIN_CMS, v->ctrl_cms,
                        0);


  xv_create (p->panel, PANEL_BUTTON,
             PANEL_LABEL_STRING, "Dismiss",
             PANEL_NOTIFY_PROC, dismiss_notify,
             XV_KEY_DATA, VIEW_KEY, v,
             0);

  {
    int i;

    p->items = (Panel_item *) malloc (sizeof (Panel_item) * NUM_INFOS);

    for (i = 0; i < NUM_INFOS; ++i)
      {
        p->items[i] = xv_create (p->panel, PANEL_TEXT,
                                 PANEL_LABEL_STRING, infos[i].name,
                                 XV_X, infos[i].x,
                                 XV_Y, infos[i].y,
                                 PANEL_READ_ONLY, TRUE,
                                 PANEL_VALUE_DISPLAY_LENGTH, infos[i].len,
                                 0);
      }



  }
  window_fit (p->panel);
  window_fit (p->frame);


}
