/* vicar.c */
void vicar_destructor(Vicar v);
int vicar_get_int(Vicar v, char *lbl, int *ret);
int vicar_get_float(Vicar v, char *lbl, float *ret);
char *vicar_get_str(Vicar v, char *lbl);
Vicar open_vicar(char *path);
void read_vicar(Vicar v);
/* image.c */
void image_destructor(Image image);
Image create_image(Create_image_args args);
void shrink_image(Image i, int s);
int get_best_x_image_type(Display *d);
/* tile.c */
void tile_destructor(Tile t);
Tile create_tile(Create_image_args args, char *path);
Tile get_tile(Create_image_args args, char *path, int shrink);
void empty_tile_cache(void);
/* projection.c */
Projection *create_projection_from_vicar(Vicar v);
/* midr.c */
void midr_destructor(Midr m);
Midr open_midr(char *path);
void display_browse_tile(Display *d, Window w, GC gc, Midr m, int s);
/* view.c */
void view_destructor(View v);
void info_at(View v, char *buf);
void info_midr_name(View v, char *buf);
void info_midr_path(View v, char *buf);
void view_register_repaint_proc(View v, void (*proc)(View));
void ext_view_repaint(View v);
XY ll_to_xy(View v, LL ll);
LL xy_to_ll(View v, XY xy);
IXY xy_to_ixy(View v, XY xy);
XY ixy_to_xy(View v, IXY ixy);
IXY ll_to_ixy(View v, LL ll);
LL ixy_to_ll(View v, IXY ixy);
View create_view(char *path);
/* grid.c */
void info_grid_step(View v, char *buf);
void grid_repaint(View v);
void grid_base_menu(View v);
/* motion.c */
void motion_base_menu(View v);
/* graphics.c */
void view_set_color(View v, int c);
void view_draw_line(View v, IXY *line, int n);
void view_DrawLine(View v, int x1, int y1, int x2, int y2);
void view_fill_centered_rectangle(View v, IXY pos, IXY size);
void view_draw_box(View v, IXY pos, int n);
void view_draw_boxes(View v, IXY *pos, int w, int n);
void view_draw_points(View v, IXY *line, int n);
void view_draw_point(View v, IXY pos);
void view_draw_string(View v, IXY pos, char *s);
void view_set_font(View v, int height);
int view_get_textwidth(View v, int h, char *s);
int view_onscreen(View v, IXY pos);
/* altimetry.c */
void arcdr_destructor(Arcdr a);
char *alt_head_get_str(char *head, char *lbl);
int alt_head_get_int(char *head, char *lbl, int *r);
int read_sfdu(FILE *f, sfdu *s);
int read_arcdr_and_update(Arcdr a, ar_rec *r);
Arcdr open_arcdr(char *path);
int arcdr_read(Arcdr a, ar_rec *d);
int arcdr_read_foot(Arcdr a, int f, ar_rec *d);
void arcdr_rewind(Arcdr a);
Arcdr open_arcdr_by_orbit(int orbit);
Arcdr get_arcdr_by_orbit(int orbit);
void update_jorb(Arcdr a);
int get_alt_filename(int orbit, char *buf);
int update_alt_lib(Arcdr a);
int orbit_to_cycle(int orbit);
int cycle_to_sorbit(int cycle);
int cycle_to_eorbit(int cycle);
int find_nearest_orbit_to(LL ll, int cycle, int err);
/* util.c */
int modish(int a, int b);
float fmodish(float a, int ib);
void commit_suicide(void);
char *mgn_getenv(char *s);
alt_rec **create_ar_matrix(int x, int y);
void free_ar_matrix(alt_rec **base);
XYZ ll_to_xyz(LL ll);
LL xyz_to_ll(XYZ xyz);
GCPath make_gcpath(LL l1, LL l2);
LL get_point_on_gcpath(GCPath p, float l);
float interpolate(LL pos[3], float h[3], LL now);
/* alttile.c */
int is_on_alttile(Alttile t, IXY pos);
void info_alttile(View v, char *buf);
void alttile_destructor(Alttile a);
void alttile_ptr_destructor(Alttile a);
void altview_private_destructor(View v);
void altview_private_init(View v);
Alttile create_alttile_from_midr(Midr m, int cycle, int type);
float evaluate_distance(LL l1, LL l2);
void alt_find_nearest_in_tile(Alttile t, LL ll, IXY *ret);
void alt_find_nearest_n_in_tile(Alttile t, LL ll, int n, IXY *ret);
int check_nearest_m_of_n_in_tile(Alttile t, LL ll, int m, int n, IXY *ret);
Valuetile alt_make_value_tile(Alttile m);
void alt_find_range(Alttile t, float *min, float *max);
/* altview.c */
Alttile alt_get_tile(View v, int cycle);
Alttile alt_get_subtile_from_view(View v, Alttile m);
void invalidate_altimetry_cache(View v);
Alttile alt_get_current_master_tile(View v);
void alt_repaint(View v);
void alt_base_menu(View v);
/* contor.c */
void info_contor_level(View v, char *buf);
void info_contor_step(View v, char *buf);
void do_contour(View v, Valuetile t, float level, int side);
value_rec **create_value_rec_matrix(int x, int y);
void free_value_rec_matrix(value_rec **base);
Valuetile create_valuetile_with_borders(IXY size);
void valuetile_destructor(Valuetile t);
void valuetile_find_range(Valuetile t, float *min, float *max);
/* return.c */
int radius_to_delay(ar_rec *r, float radius);
float delay_to_radius(ar_rec *r, int delay);
int unwrap_delay(ar_rec *r, int delay);
int wrapup_delay(ar_rec *r, int delay);
void return_repaint(View v);
void return_private_destructor(View v);
void return_private_init(View v);
void return_notify(Menu m, Menu_item mi);
/* info.c */
void info_repaint(View v);
void info_base_menu(View v);
void info_private_destructor(View v);
void info_private_init(View v);
/* altcontor.c */
void alt_contour_menu(View v, Menu base);
/* whereami.c */
void whereami_base_menu(View v);
void whereami_private_destructor(View v);
void whereami_private_init(View v);
/* profile.c */
int profile_event(View v, Event *e);
void profile_repaint(View v, Alttile t);
void profile_add_menu(View v, Menu m);
void profile_private_destructor(View v);
void profile_private_init(View v);
