/*
 * $Log: midr.c,v $
 * Revision 14.0  1998/07/31 19:46:47  root
 * \#makecheckin
 *
 * Revision 13.0  1998/07/31 19:46:30  root
 * \#makecheckin
 *
 * Revision 12.0  1998/07/31 09:58:26  root
 * \#makecheckin
 *
 * Revision 11.0  1998/05/02 23:03:44  root
 * \#makecheckin
 *
 * Revision 10.1  1997/10/22 18:35:48  root
 * \#makecheckin
 *
 * Revision 10.0  1997/10/22 18:33:55  root
 * \#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 * Revision 5.0  1997/07/03 15:05:48  root
 * \#makecheckin
 *
 * Revision 4.0  1997/07/01 11:58:59  root
 * \#makecheckin
 *
 * Revision 3.0  1997/06/23 12:51:50  root
 * \#makecheckin
 *
 * Revision 2.0  1997/06/23 09:04:44  root
 * \#makecheckin
 *
 * Revision 1.11  1997/06/23 08:53:02  root
 * \#makecheckin
 *
 * Revision 1.10  1997/06/18 15:15:32  root
 * \#makecheckin
 *
 * Revision 1.9  1997/06/15 23:47:48  root
 * \#makecheckin
 *
 */

static char rcsid[] = "$Id: midr.c,v 14.0 1998/07/31 19:46:47 root Exp root $";

#include "mgn.h"

void
midr_destructor (Midr m)
{
  if (m->prefix)
    free (m->prefix);
  if (m->path)
    free (m->path);
  if (m->browse)
    Obj_Delete (m->browse);
  if (m->browse_proj)
    free (m->browse_proj);
  free (m);

  empty_tile_cache ();
}


static int
std56_name (MXY mxy, char *buf)
{

  if (mxy.x < 0)
    return (0);
  if (mxy.y < 0)
    return (0);

  mxy.x >>= 10;
  mxy.y >>= 10;

  if (mxy.x > 7)
    return (0);
  if (mxy.y > 6)
    return (0);

  mxy.y <<= 3;
  mxy.y += mxy.x + 1;

  sprintf (buf, "%s/%s%02d.img", mxy.m->path, mxy.m->prefix, mxy.y);
  return (1);
}


static TXY
std56_mxy_to_txy (Create_image_args args, MXY mxy)
{
  char buf[1024];
  TXY txy;

  txy.t = NULL;
  txy.x = txy.y = 0;

  if (std56_name (mxy, buf) == 0)
    return (txy);


  txy.t = get_tile (args, buf, 1);
  if (!txy.t)
    return (txy);

  txy.x = modish (mxy.x, 1024);
  txy.y = modish (mxy.y, 1024);

  return (txy);
}

static void
std56_display_chunk (Display * d, Window w, GC gc, MXY mxy,
                     int wx, int wy)
{
  char buf[1024];
  int x, y;
  int px = 0, py = 0;
  MXY m;

  TXY txy;
  Create_image_args args;




  args.type = get_best_x_image_type (d);

  switch (args.type)
    {
    case MGN_XIMAGE:
      args.p.x.display = d;
      break;
    case MGN_SHXIMAGE:
      args.p.shx.display = d;
      args.p.shx.window = w;
      break;
    case MGN_NPSHXIMAGE:
      args.p.npshx.display = d;
      break;
    default:
      fprintf (MOAN, "midr: std56_display_chunk	unknown image type selected\n");
      return;
    }



  XSetForeground (d, gc, MGN_WHITE);
  XSetFunction (d, gc, GXcopy);

  while (py < wy)
    {
      px = 0;

      while (px < wx)
        {

          m = mxy;
          m.x += px;
          m.y += py;

          txy = std56_mxy_to_txy (args, m);

          if (!txy.t)
            {
              txy.x = modish (m.x, 1024);
              txy.y = modish (m.y, 1024);
              XFillRectangle (d, w, gc, px, py, 1024 - txy.x, 1024 - txy.y);

            }
          else
            {
              txy.t->image->funcs.copyarea_to_x (txy.t->image, d, w, gc,
                          txy.x, txy.y, 1024 - txy.x, 1024 - txy.y, px, py);
            }
          px += 1024 - txy.x;
        }

      py += 1024 - txy.y;

    }


}

static LL
std56_xy_to_ll (Midr midr, XY xy)
{
  LL ll =
  {0.0, 0.0};
  MXY m;
  TXY t;
  Create_image_args args;

  m.m = midr;
  m.x = (int) xy.x;
  m.y = (int) xy.y;

  args.type = MGN_NO_IMAGE;

  t = std56_mxy_to_txy (args, m);

  if (!t.t)
    {
      xy.x *= 0.125;
      xy.y *= 0.125;

      if (!midr->browse_proj)
        return (ll);

      ll = midr->browse_proj->funcs.xy_to_ll (midr->browse_proj, xy);

      return (ll);
    }

  xy.x -= (float) m.x;
  xy.y -= (float) m.y;

  xy.x += (float) t.x;
  xy.y += (float) t.y;

  ll = t.t->proj->funcs.xy_to_ll (t.t->proj, xy);

  return (ll);

}

static XY
std56_ll_to_xy (Midr midr, LL ll)
{
  XY xy =
  {0, 0};
  MXY m;
  TXY t;
  Create_image_args args;

  if (!midr->browse_proj)
    return (xy);

  xy = midr->browse_proj->funcs.ll_to_xy (midr->browse_proj, ll);
  xy.x *= 8.0;
  xy.y *= 8.0;

  m.m = midr;
  m.x = (int) xy.x;
  m.y = (int) xy.y;

  args.type = MGN_NO_IMAGE;

  t = std56_mxy_to_txy (args, m);

  if (!t.t)
    return (xy);

  xy = t.t->proj->funcs.ll_to_xy (t.t->proj, ll);
  xy.x += (float) ((m.x >> 10) << 10);
  xy.y += (float) ((m.y >> 10) << 10);

  return (xy);


}



static struct midr_funcs std56_funcs =
{std56_mxy_to_txy, std56_display_chunk,
 std56_xy_to_ll, std56_ll_to_xy};

/* horrible hack but there probably isn't a better way... */

static Midr
open_std56 (char *path)
{
  Midr m = CREATE_OBJ (Midr);
  char buf[1024];
  Vicar v;


/* First figure the prefix */
  {
    char *pref[] =
    {"ff", "c1f", "c2f", "c3f", NULL};
    char **ptr = pref;

    while (*ptr)
      {

        strcpy (buf, path);
        strcat (buf, "/");
        strcat (buf, *ptr);
        strcat (buf, "01.img");

        v = open_vicar (buf);
        if (v)
          {
            Obj_Delete (v);
            m->prefix = strdup (*ptr);
            break;
          }

        *ptr++;
      }

    if (!m->prefix)
      {
        Obj_Delete (m);
        return (NULL);
      }

    fprintf (MOAN, "midr: prefix of %s is %s\n", path, m->prefix);
  }


  m->path = strdup (path);

  strcpy (buf, path);
  strcat (buf, "/");
  strcat (buf, m->prefix);
  strcat (buf, "56.img");

  v = open_vicar (buf);
  if (!v)
    {
      Obj_Delete (m);
      return (NULL);
    }

  Obj_Delete (v);


  strcpy (buf, path);
  strcat (buf, "/");
  strcat (buf, m->prefix);
  strcat (buf, "57.img");

  v = open_vicar (buf);
  if (v)
    {
      Obj_Delete (v);
      Obj_Delete (m);
      return (NULL);
    }



  m->funcs = std56_funcs;
  m->type = MIDR_STD56;


  strcpy (buf, path);
  strcat (buf, "/");
  strcat (buf, "browse.img");

  v = open_vicar (buf);
  if (v)
    {
      fclose (v->file);
      v->file = NULL;
    }
  m->browse = v;

  m->browse_proj = create_projection_from_vicar (v);
  m->max_x = 8192;
  m->max_y = 7168;

  return (m);

}




Midr
open_midr (char *path)
{
  Midr m = NULL;

  if (!m)
    m = open_std56 (path);


  if (!m)
    {
      fprintf (MOAN, "midr: canot determine type of midr in %s\n", path);
    }


  return (m);
}

void
display_browse_tile (Display * d, Window w, GC gc, Midr m, int s)
{
  char buf[1024];
  Create_image_args args;
  Tile t;

  args.type = get_best_x_image_type (d);

  switch (args.type)
    {
    case MGN_XIMAGE:
      args.p.x.display = d;
      break;
    case MGN_SHXIMAGE:
      args.p.shx.display = d;
      args.p.shx.window = w;
      break;
    case MGN_NPSHXIMAGE:
      args.p.npshx.display = d;
      break;
    default:
      fprintf (MOAN, "midr: display_browse_tile	unknown image type selected\n");
      return;
    }


  strcpy (buf, m->path);
  strcat (buf, "/");
  strcat (buf, "browse.img");

  t = get_tile (args, buf, s);

  t->image->funcs.copyarea_to_x (t->image, d, w, gc, 0, 0, t->image->x,
                                 t->image->y, 0, 0);


}
