/*
 * $Log: motion.c,v $
 * Revision 14.0  1998/07/31 19:46:47  root
 * \#makecheckin
 *
 * Revision 13.0  1998/07/31 19:46:30  root
 * \#makecheckin
 *
 * Revision 12.0  1998/07/31 09:58:26  root
 * \#makecheckin
 *
 * Revision 11.0  1998/05/02 23:03:44  root
 * \#makecheckin
 *
 * Revision 10.1  1997/10/22 18:35:48  root
 * \#makecheckin
 *
 * Revision 10.0  1997/10/22 18:33:55  root
 * \#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 * Revision 5.0  1997/07/03 15:05:48  root
 * \#makecheckin
 *
 * Revision 4.0  1997/07/01 11:58:59  root
 * \#makecheckin
 *
 * Revision 3.0  1997/06/23 12:51:50  root
 * \#makecheckin
 *
 * Revision 2.0  1997/06/23 09:04:44  root
 * \#makecheckin
 *
 * Revision 1.8  1997/06/23 08:53:03  root
 * \#makecheckin
 *
 * Revision 1.7  1997/06/18 15:15:32  root
 * \#makecheckin
 *
 * Revision 1.6  1997/06/15 23:47:48  root
 * \#makecheckin
 *
 */

static char rcsid[] = "$Id: motion.c,v 14.0 1998/07/31 19:46:47 root Exp root $";

#include "mgn.h"

#include "arrows/arrows.h"

static void
motion_notify (Menu m, Menu_item mi)
{
  View v = (View) xv_get (mi, XV_KEY_DATA, VIEW_KEY);
  int i = (int) xv_get (mi, XV_KEY_DATA, MOTION_KEY);
  int x, y;

  x = i / 3;
  y = i % 3;
  x--;
  y--;

  x *= (v->wx >> 1);
  y *= (v->wy >> 1);

  printf ("Motion key gives %d => (%d,%d)\n", i, x, y);

  v->x += x;
  v->y += y;

  invalidate_altimetry_cache (v);
  ext_view_repaint (v);

}
static void
panel_motion_notify (Panel_item item)
{

  View v = (View) xv_get (item, XV_KEY_DATA, VIEW_KEY);
  int i = (int) xv_get (item, XV_KEY_DATA, MOTION_KEY);
  int x, y;

  x = i / 3;
  y = i % 3;
  x--;
  y--;

  x *= (v->wx >> 1);
  y *= (v->wy >> 1);

  printf ("Motion key gives %d => (%d,%d)\n", i, x, y);

  v->x += x;
  v->y += y;

  invalidate_altimetry_cache (v);
  ext_view_repaint (v);



}

static void
create_pin_win (View v, Menu menu)
{

  Frame cmd_frame = (Frame) xv_create (v->frame, FRAME_CMD, XV_SHOW, FALSE, NULL);
  Panel panel = (Panel) xv_get (cmd_frame, FRAME_CMD_PANEL);

  int i, x, y;

  for (i = 0; i < ARROW_NUM; ++i)
    {
      x = i / 3;
      y = i % 3;
      x *= 42;
      y *= 42;
      x += 5;
      y += 5;

      xv_create (panel, PANEL_BUTTON,
                 PANEL_LABEL_IMAGE, arrow[i],
                 PANEL_NOTIFY_PROC, panel_motion_notify,
                 XV_KEY_DATA, VIEW_KEY, v,
                 XV_KEY_DATA, MOTION_KEY, i,
                 XV_X, x,
                 XV_Y, y,
                 NULL);
    }
  window_fit (panel);
  window_fit (cmd_frame);
  xv_set (menu, MENU_PIN_WINDOW, cmd_frame, NULL);
}


void
motion_base_menu (View v)
{
  Menu m;
  Menu_item mi;
  int i;

  m = xv_create (0, MENU,
                 MGN_PIN (v, "Motion")
                 MENU_NCOLS, 3,
                 MENU_NROWS, 3,
                 0);

  init_arrows ();

  for (i = 0; i < ARROW_NUM; ++i)
    {

      mi = xv_create (0, MENUITEM,
                      MENU_IMAGE, arrow[i],
                      XV_KEY_DATA, VIEW_KEY, v,
                      XV_KEY_DATA, MOTION_KEY, i,
                      MENU_NOTIFY_PROC, motion_notify,
                      0);
      xv_set (m, MENU_APPEND_ITEM, mi, 0);
    }


  create_pin_win (v, m);


  xv_set (v->menu, MENU_PULLRIGHT_ITEM, "Motion", m, 0);


}
