/*
 * $Log: return.c,v $
 * Revision 14.0  1998/07/31 19:46:47  root
 * \#makecheckin
 *
 * Revision 13.0  1998/07/31 19:46:30  root
 * \#makecheckin
 *
 * Revision 12.0  1998/07/31 09:58:26  root
 * \#makecheckin
 *
 * Revision 11.0  1998/05/02 23:03:44  root
 * \#makecheckin
 *
 * Revision 10.2  1998/04/24 20:58:37  root
 * \#makecheckin
 *
 * Revision 10.1  1997/10/22 18:35:49  root
 * \#makecheckin
 *
 * Revision 10.0  1997/10/22 18:33:55  root
 * \#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 * Revision 5.1  1997/07/04 00:31:03  root
 * \#makecheckin
 *
 * Revision 5.0  1997/07/03 15:05:48  root
 * \#makecheckin
 *
 * Revision 4.0  1997/07/01 11:58:59  root
 * \#makecheckin
 *
 * Revision 3.1  1997/07/01 11:58:46  root
 * \#makecheckin
 *
 * Revision 3.0  1997/06/23 12:51:50  root
 * \#makecheckin
 *
 * Revision 2.0  1997/06/23 09:04:44  root
 * \#makecheckin
 *
 * Revision 1.8  1997/06/18 15:15:32  root
 * \#makecheckin
 *
 * Revision 1.7  1997/06/15 23:47:49  root
 * \#makecheckin
 *
 */

static char rcsid[] = "$Id: return.c,v 14.0 1998/07/31 19:46:47 root Exp root $";

#include "mgn.h"

#define RETURN_WIDTH 350
#define RETURN_HEIGHT 300

#define RETURN_INDENT 25

#undef PI

#include "tmpl.h"


int
radius_to_delay (ar_rec * r, float radius)
{
  int delay;

  if (!r)
    return (0);

  radius -= r->ar_radius2;

  radius *= 4.0 * BANDWIDTH / VELC;
  radius += 0.5;
  delay = (int) radius;

  delay = r->ar_thresh - delay;
  delay = modish (delay, ALT_RETURN_LENGTH);

  return (delay);
}

float
delay_to_radius (ar_rec * r, int delay)
{
  float rad;

  if (!r)
    return (0.0);
  if ((delay < 0) || (delay > 301))
    return (0.0);


  delay = r->ar_thresh - delay;
  delay += HALF_RETURN_LENGTH;
  delay = modish (delay, ALT_RETURN_LENGTH);
  delay -= HALF_RETURN_LENGTH;

  rad = (float) delay;
  rad *= 0.25 * VELC / BANDWIDTH;

  rad += r->ar_radius2;

  return (rad);
}



int
unwrap_delay (ar_rec * r, int delay)
{

  delay -= r->ar_thresh;

  delay = modish (delay, ALT_RETURN_LENGTH);

  if (delay > HALF_RETURN_LENGTH)
    delay -= ALT_RETURN_LENGTH;

  return (delay);
}

int
wrapup_delay (ar_rec * r, int delay)
{

  delay += r->ar_thresh;

  delay = modish (delay, ALT_RETURN_LENGTH);

  return (delay);
}


static void
update_panel (Return_private * p)
{
  char buf[80];
  sprintf (buf, "%d", p->pos.orbit);
  xv_set (p->porbit, PANEL_VALUE, buf, 0);

  sprintf (buf, "%d", p->pos.foot);
  xv_set (p->pfoot, PANEL_VALUE, buf, 0);

}


static void return_print_radius(View v)
{
  Return_private *p = v->return_private;
  char buf[80];

  if (!p->delay_picked) {
  xv_set(p->prad,PANEL_VALUE,"",NULL);

    return;
  }
	
  sprintf(buf,"%.4f km",p->picked_rad);
  xv_set(p->prad,PANEL_VALUE,buf,NULL);
}

#define FLIP(a) ((255-(a))+RETURN_INDENT)

static void
return_canvas_repaint (Canvas c)
{
  View v = (View) xv_get (c, XV_KEY_DATA, VIEW_KEY);
  Return_private *p = v->return_private;
  int sharp = xv_get (p->psharp, PANEL_VALUE);
  ar_rec r;
  int i, j;
  uchar *prof, *tmpl;
  int of;
  int x;
  int xo;
  Arcdr a;

  XSetForeground (p->display, p->gc, MGN_BLACK);
  XFillRectangle (p->display, p->window, p->gc, 0, 0, RETURN_WIDTH,
                  RETURN_HEIGHT);

  update_panel (p);

  if (!p->on)
    return;

  a = get_arcdr_by_orbit (p->pos.orbit);

  if (!a)
    return;

  if (!arcdr_read_foot (a, p->pos.foot, &r))
    return;

  if (sharp)
    {
      prof = r.ar_rsprof;
      tmpl = r.ar_rstmpl;
      of = r.ar_rsnprof0;
    }
  else
    {
      prof = r.ar_prof;
      tmpl = r.ar_tmpl;
      of = r.ar_nprof0;
    }

  xo = 0;

  for (i = 0; i < ALT_RETURN_LENGTH; ++i)
    {

      x = unwrap_delay (&r, i);
      if (x < xo)
        xo = x;

    }

  xo = -xo;
  xo += RETURN_INDENT;
  
  p->delay_org=xo;

  XSetForeground (p->display, p->gc, MGN_GREEN);

  for (i = 0; i < ALT_RETURN_LENGTH; ++i)
    {
      x = xo + unwrap_delay (&r, i);

      XDrawLine (p->display, p->window, p->gc, x, FLIP (0), x, FLIP (prof[i]));

    }



  XSetForeground (p->display, p->gc, MGN_YELLOW);
  for (j = 0; j < ALT_TEMPLATE_LENGTH; ++j)
    {
      i = j + of;
      i %= ALT_RETURN_LENGTH;
      x = xo + unwrap_delay (&r, i);


      if (tmpl[j] <= prof[i])
        {
          XDrawLine (p->display, p->window, p->gc,
                     x, FLIP (0), x, FLIP (tmpl[j]));
        }
      else
        {
          XDrawLine (p->display, p->window, p->gc,
                     x, FLIP (0), x, FLIP (prof[i]));
        }

    }

  XSetForeground (p->display, p->gc, MGN_RED);
  for (j = 0; j < ALT_TEMPLATE_LENGTH; ++j)
    {
      i = j + of;
      i %= ALT_RETURN_LENGTH;

      x = xo + unwrap_delay (&r, i);

      if (tmpl[j] > prof[i])
        {
          XDrawLine (p->display, p->window, p->gc,
                     x, FLIP (prof[i]), x, FLIP (tmpl[j]));
        }
    }

  XSetForeground (p->display, p->gc, MGN_BLUE);

  i = radius_to_delay (&r, r.ar_radius);

  x = xo + unwrap_delay (&r, i);

  XDrawLine (p->display, p->window, p->gc,
             x, FLIP (-5), x, FLIP (260));

  XSetForeground (p->display, p->gc, MGN_WHITE);

  if (!p->delay_picked) {
	p->delay_picked=x;
	p->picked_rad=r.ar_radius;
  }

  x = p->delay_picked;

  XDrawLine (p->display, p->window, p->gc,
             x, FLIP (-5), x, FLIP (260));



  return_print_radius(v);


}

static void
return_set_rad (Panel_item item)
{
  View v = (View) xv_get (item, XV_KEY_DATA, VIEW_KEY);
  float value = atof ((char *) xv_get (item, PANEL_VALUE));
  Return_private *p = v->return_private;
  int delay;
  Arcdr a;
  ar_rec r;
  

  p->picked_rad=value;

  if (!p->on)
    return;

  a = get_arcdr_by_orbit (p->pos.orbit);

  if (!a)
    return;

  if (!arcdr_read_foot (a, p->pos.foot, &r))
    return;


  delay=radius_to_delay (&r, p->picked_rad);


  p->delay_picked=p->delay_org + unwrap_delay (&r, delay);
  

  return_canvas_repaint(p->canvas);

}


static void return_recalc_delay(View v)
{
  Return_private *p = v->return_private;
  int delay;
  Arcdr a;
  ar_rec r;
  


  if (!p->on)
    return;

  if (!p->delay_picked) {
	return_print_radius(v);
        return;
  }

  a = get_arcdr_by_orbit (p->pos.orbit);

  if (!a)
    return;

  if (!arcdr_read_foot (a, p->pos.foot, &r))
    return;

  delay=(p->delay_picked)-(p->delay_org);
  

  delay = wrapup_delay (&r,delay);




  p->picked_rad=delay_to_radius (&r, delay);


  return_print_radius(v);
}


static void 
return_canvas_event (Canvas canvas,Event *event)
{
  int ex, ey;
  int ac;
  View v = (View) xv_get (canvas, XV_KEY_DATA, VIEW_KEY);
  Return_private *p = v->return_private;

  ac = event_action (event);
  ex = event_x (event);
  ey = event_y (event);

  if (ac == ACTION_SELECT)
    ac = MS_LEFT;
  if (ac == ACTION_ADJUST)
    ac = MS_MIDDLE;
  if (ac == ACTION_MENU)
    ac = MS_RIGHT;


  if (((int) event_left_is_down (event)) || (ac==MS_LEFT))
    {
	p->delay_picked=ex;
	return_recalc_delay(v);
    }

  if (((int) event_is_up (event)) && (ac==MS_LEFT))
    {
	p->delay_picked=ex;

	return_canvas_repaint(canvas);
    }

}

static void return_update(Panel_item pi)
{
  View v = (View) xv_get (pi, XV_KEY_DATA, VIEW_KEY);
  Return_private *p = v->return_private;
  Alttile t;

  IXY pos;
 
  t=alt_get_current_master_tile(v);
  if (!t) return;

  pos=t->funcs.iof_to_ixy (t, p->pos);

  if (!is_on_alttile(t,pos)) return;

  t->data[pos.x][pos.y].rad=p->picked_rad;

  invalidate_altimetry_cache(v);

  ext_view_repaint (v);

}

static void return_reset(Panel_item pi)
{
  View v = (View) xv_get (pi, XV_KEY_DATA, VIEW_KEY);
  Return_private *p = v->return_private;
 
  p->delay_picked=0;
  
  return_canvas_repaint(p->canvas);

  return_update(pi);
}

void
return_repaint (View v)
{
  Return_private *p = v->return_private;
  ar_rec r;
  LL ll;
  IXY ixy;
  Arcdr a;

  if (!p->on)
    return;

  a = get_arcdr_by_orbit (p->pos.orbit);

  if (!a)
    return;

  if (!arcdr_read_foot (a, p->pos.foot, &r))
    return;

  ll.lat = r.ar_lat;
  ll.lon = r.ar_lon;

  ixy = ll_to_ixy (v, ll);

  view_set_color (v, MGN_YELLOW);
  view_draw_box (v, ixy, 9);


}



void
return_private_destructor (View v)
{
  if (v->return_private)
    {

      XFreeGC (v->return_private->display, v->return_private->gc);

      free (v->return_private);
      v->return_private = NULL;

    }

}


static void
return_done_proc (Panel_item item)
{
  View v = (View) xv_get (item, XV_KEY_DATA, VIEW_KEY);
  xv_set (v->return_private->frame, XV_SHOW, FALSE, 0);
  v->return_private->on = 0;

}

static void
return_do_repaint (Panel_item item)
{
  View v = (View) xv_get (item, XV_KEY_DATA, VIEW_KEY);
  return_canvas_repaint (v->return_private->canvas);

}

static void
return_step_proc (Panel_item item)
{
  View v = (View) xv_get (item, XV_KEY_DATA, VIEW_KEY);
  int s = (int) xv_get (item, XV_KEY_DATA, RETURN_STEP_KEY);

  switch (s)
    {
    case 1:
      v->return_private->pos.foot--;
      break;
    case 2:
      v->return_private->pos.foot++;
      break;
    case 3:
      v->return_private->pos.orbit--;
      break;
    case 4:
      v->return_private->pos.orbit++;
      break;
    }

  v->return_private->delay_picked=0;

  return_recalc_delay(v);

  ext_view_repaint (v);

  return_canvas_repaint (v->return_private->canvas);

}


static void
return_set_value (Panel_item item)
{
  View v = (View) xv_get (item, XV_KEY_DATA, VIEW_KEY);
  int *s = (int *) xv_get (item, XV_KEY_DATA, RETURN_STEP_KEY);
  int value = atoi ((char *) xv_get (item, PANEL_VALUE));

  *s = value;


  ext_view_repaint (v);

  return_canvas_repaint (v->return_private->canvas);

}


void
return_private_init (View v)
{
  XGCValues gcv;

  v->return_private = (Return_private *) malloc (sizeof (Return_private));

  v->return_private->frame = xv_create (v->frame, FRAME,
                                        FRAME_SHOW_LABEL, FALSE,
                                        FRAME_SHOW_RESIZE_CORNER, FALSE,
                                        XV_SHOW, FALSE,
                                        XV_WIDTH, RETURN_WIDTH,
                                        0);

  v->return_private->panel = xv_create (v->return_private->frame, PANEL,
                                        WIN_CMS, v->ctrl_cms,
                                        XV_X, 0, XV_Y, 0,
                                        XV_WIDTH, RETURN_WIDTH,
                                        XV_HEIGHT, 120,
                                        0);

  xv_create (v->return_private->panel, PANEL_BUTTON,
             PANEL_LABEL_STRING, "Done",
             PANEL_NOTIFY_PROC, return_done_proc,
             XV_KEY_DATA, VIEW_KEY, v,
             0);

  xv_create (v->return_private->panel, PANEL_BUTTON,
             PANEL_LABEL_STRING, "Foot -",
             PANEL_NOTIFY_PROC, return_step_proc,
             XV_KEY_DATA, VIEW_KEY, v,
             XV_KEY_DATA, RETURN_STEP_KEY, 1,
             0);
  xv_create (v->return_private->panel, PANEL_BUTTON,
             PANEL_LABEL_STRING, "Foot +",
             PANEL_NOTIFY_PROC, return_step_proc,
             XV_KEY_DATA, VIEW_KEY, v,
             XV_KEY_DATA, RETURN_STEP_KEY, 2,
             0);
  xv_create (v->return_private->panel, PANEL_BUTTON,
             PANEL_LABEL_STRING, "Orbit -",
             PANEL_NOTIFY_PROC, return_step_proc,
             XV_KEY_DATA, VIEW_KEY, v,
             XV_KEY_DATA, RETURN_STEP_KEY, 3,
             0);
  xv_create (v->return_private->panel, PANEL_BUTTON,
             PANEL_LABEL_STRING, "Orbit +",
             PANEL_NOTIFY_PROC, return_step_proc,
             XV_KEY_DATA, VIEW_KEY, v,
             XV_KEY_DATA, RETURN_STEP_KEY, 4,
             0);

  v->return_private->psharp = xv_create (v->return_private->panel, PANEL_CHOICE,
          PANEL_CHOICE_STRINGS, "Non Range Sharpened", "Range Sharpened", 0,
                                         XV_KEY_DATA, VIEW_KEY, v,
                                         PANEL_VALUE, 1,
                                       PANEL_NOTIFY_PROC, return_do_repaint,
                                         0);

  v->return_private->porbit = xv_create (v->return_private->panel, PANEL_TEXT,
                                         PANEL_LABEL_STRING, "Orbit:",
                                         PANEL_VALUE_DISPLAY_LENGTH, 8,
                                         PANEL_NOTIFY_PROC, return_set_value,
                                         XV_KEY_DATA, VIEW_KEY, v,
                XV_KEY_DATA, RETURN_STEP_KEY, &v->return_private->pos.orbit,
                                         0);
  v->return_private->pfoot = xv_create (v->return_private->panel, PANEL_TEXT,
                                        PANEL_LABEL_STRING, "Foot:",
                                        PANEL_VALUE_DISPLAY_LENGTH, 8,
                                        PANEL_NOTIFY_PROC, return_set_value,
                                        XV_KEY_DATA, VIEW_KEY, v,
                 XV_KEY_DATA, RETURN_STEP_KEY, &v->return_private->pos.foot,
                                        0);


  v->return_private->prad=xv_create (v->return_private->panel, PANEL_TEXT,
                                         PANEL_LABEL_STRING, "Picked radius:",
                                         PANEL_VALUE_DISPLAY_LENGTH, 12,
                                         PANEL_NOTIFY_PROC, return_set_rad,
                                         XV_KEY_DATA, VIEW_KEY, v,
                                         0);

  xv_create (v->return_private->panel, PANEL_BUTTON,
             PANEL_LABEL_STRING, "Update",
             PANEL_NOTIFY_PROC, return_update,
             XV_KEY_DATA, VIEW_KEY, v,
             0);
  xv_create (v->return_private->panel, PANEL_BUTTON,
             PANEL_LABEL_STRING, "Reset",
             PANEL_NOTIFY_PROC, return_reset,
             XV_KEY_DATA, VIEW_KEY, v,
             0);


  v->return_private->canvas = xv_create (v->return_private->frame, CANVAS,
                                         XV_X, 0, XV_Y, 120,
                                         WIN_CMS, v->cms,
                                         XV_WIDTH, RETURN_WIDTH,
                                         XV_HEIGHT, RETURN_HEIGHT,
                                         CANVAS_RETAINED, FALSE,
                                 CANVAS_REPAINT_PROC, return_canvas_repaint,
                                         XV_KEY_DATA, VIEW_KEY, v,
                                         0);

  xv_set(canvas_paint_window(v->return_private->canvas),
          XV_KEY_DATA, VIEW_KEY, v,
	  WIN_EVENT_PROC,return_canvas_event,
          WIN_CONSUME_EVENTS,
          KBD_DONE, KBD_USE, LOC_DRAG, WIN_MOUSE_BUTTONS,
          LOC_WINEXIT,
          NULL,
          NULL);


  window_fit (v->return_private->frame);

  v->return_private->pos.foot = 0;
  v->return_private->pos.orbit = 0;

  v->return_private->display = (Display *) xv_get (v->return_private->canvas, XV_DISPLAY);
  v->return_private->window = xv_get (canvas_paint_window (v->return_private->canvas), XV_XID);

  gcv.graphics_exposures = False;
  gcv.foreground = 255;
  v->return_private->gc =
    XCreateGC (v->return_private->display,
               v->return_private->window, GCGraphicsExposures, &gcv);


}





void
return_notify (Menu m, Menu_item mi)
{
  View v = (View) xv_get (mi, XV_KEY_DATA, VIEW_KEY);
  Alttile t = v->altview_private->current;

  IXY pos;
  LL ll;

  if (!t)
    return;

  ll = ixy_to_ll (v, v->menu_pos);
  alt_find_nearest_in_tile (t, ll, &pos);

  v->return_private->pos = t->funcs.ixy_to_iof (t, pos);


  xv_set (v->return_private->frame, XV_SHOW, TRUE, 0);
  v->return_private->on = 1;

  ext_view_repaint (v);
  return_canvas_repaint (v->return_private->canvas);

}
