/*
 * $Log: whereami.c,v $
 * Revision 14.0  1998/07/31 19:46:47  root
 * \#makecheckin
 *
 * Revision 13.0  1998/07/31 19:46:30  root
 * \#makecheckin
 *
 * Revision 12.0  1998/07/31 09:58:26  root
 * \#makecheckin
 *
 * Revision 11.0  1998/05/02 23:03:44  root
 * \#makecheckin
 *
 * Revision 10.1  1997/10/22 18:35:50  root
 * \#makecheckin
 *
 * Revision 10.0  1997/10/22 18:33:55  root
 * \#makecheckin
 *
 * Revision 9.0  1997/10/22 18:32:48  root
 * \#makecheckin
 *
 * Revision 8.0  1997/10/22 18:32:00  root
 * \#makecheckin
 *
 * Revision 7.0  1997/10/22 18:31:42  root
 * \#makecheckin
 *
 */

static char rcsid[] = "$Id: whereami.c,v 14.0 1998/07/31 19:46:47 root Exp root $";

#include "mgn.h"

#define WHEREAMI_WIDTH 200


void
whereami_event (View v, Event * e)
{
  Whereami_private *p = v->whereami_private;
  char buf[1024];
  LL ll;
  IXY ixy;

  if (!p)
    return;

  if (!p->on)
    return;

  ixy.x = event_x (e);
  ixy.y = event_y (e);

  ll = ixy_to_ll (v, ixy);

  sprintf (buf, "Lat %.3f Lon %.3f", ll.lat, ll.lon);

  xv_set (p->item,
          PANEL_VALUE, buf,
          0);


}

static void
dismiss_notify (Panel_item i)
{
  View v = (View) xv_get (i, XV_KEY_DATA, VIEW_KEY);
  Whereami_private *p = v->whereami_private;

  if (!p)
    return;

  xv_set (p->frame, XV_SHOW, FALSE, 0);
  p->on = 0;


}


static void
whereami_notify (Menu m, Menu_item mi)
{
  View v = (View) xv_get (mi, XV_KEY_DATA, VIEW_KEY);
  Whereami_private *p = v->whereami_private;

  if (!p)
    return;

  xv_set (p->frame, XV_SHOW, TRUE, 0);
  p->on = 1;

}

void
whereami_base_menu (View v)
{

  Menu_item mi;


  mi = xv_create (0, MENUITEM,
                  MENU_STRING, "Whereami",
                  MENU_NOTIFY_PROC, whereami_notify,
                  XV_KEY_DATA, VIEW_KEY, v,
                  0);


  xv_set (v->menu, MENU_APPEND_ITEM, mi, 0);



}

void
whereami_private_destructor (View v)
{
  if (v->whereami_private)
    {

      free (v->whereami_private);
      v->whereami_private = NULL;

    }

}

void
whereami_private_init (View v)
{
  Whereami_private *p;

  p = v->whereami_private = (Whereami_private *) malloc (sizeof (Whereami_private));

  p->frame = xv_create (v->frame, FRAME,
                        XV_WIDTH, WHEREAMI_WIDTH,
                        FRAME_SHOW_LABEL, FALSE,
                        WIN_CMS, v->ctrl_cms,
                        XV_SHOW, FALSE,
                        0);


  p->panel = xv_create (p->frame, PANEL,
                        XV_WIDTH, WHEREAMI_WIDTH,
                        WIN_CMS, v->ctrl_cms,
                        0);


  xv_create (p->panel, PANEL_BUTTON,
             PANEL_LABEL_STRING, "Dismiss",
             PANEL_NOTIFY_PROC, dismiss_notify,
             XV_KEY_DATA, VIEW_KEY, v,
             0);

  p->item = xv_create (p->panel, PANEL_TEXT,
                       PANEL_LABEL_STRING, "You are at:",
                       PANEL_READ_ONLY, TRUE,
                       PANEL_VALUE_DISPLAY_LENGTH, 20,
                       0);
  window_fit (p->panel);
  window_fit (p->frame);


}
