/*
 *$Log: projection.h,v $
 *Revision 1.1  1998/07/31 16:59:48  root
 *makecheckin
 *
 *Revision 12.0  1998/07/31 09:58:26  root
 *\#makecheckin
 *
 *Revision 11.0  1998/05/02 23:03:44  root
 *\#makecheckin
 *
 *Revision 10.0  1997/10/22 18:33:55  root
 *\#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 *Revision 5.0  1997/07/03 15:05:48  root
 *\#makecheckin
 *
 *Revision 4.0  1997/07/01 11:58:59  root
 *\#makecheckin
 *
 *Revision 3.0  1997/06/23 12:51:50  root
 *\#makecheckin
 *
 *Revision 2.0  1997/06/23 09:04:44  root
 *\#makecheckin
 *
 *Revision 1.6  1997/06/18 15:15:32  root
 *\#makecheckin
 *
 *Revision 1.5  1997/06/15 23:47:49  root
 *\#makecheckin
 *
 */



#define PROJ_RESERVED 0
#define PROJ_NONE 1
#define PROJ_LIN 2
#define PROJ_SINUSOIDAL 3

struct proj_sin_data {
	float projsamp;
	float projlong;
	float lat_ul;
	float lat_ll;
 	float a;
};

struct proj_lin_data {
	float m[2][2];
};


typedef struct {
float x,y;
} XY;

struct projection_struct;

struct proj_funcs {
	XY (*ll_to_xy)(struct projection_struct *,LL);
	LL (*xy_to_ll)(struct projection_struct *,XY);
};




typedef struct projection_struct {
int type;

union {
	struct proj_lin_data lin;
	struct proj_sin_data sin;
} data;

struct proj_funcs funcs;
float center_lon;
} Projection;

