/* 
 * $Log: util.c,v $
 * Revision 1.5  1998/07/31 16:59:48  root
 * makecheckin
 *
 * Revision 1.4  1997/06/15 23:36:54  root
 * makecheckin
 *
 */

static char rcsid[]="$Id: util.c,v 1.5 1998/07/31 16:59:48 root Exp root $";



#include "vfs.h"
#include <signal.h>

void vfs_write_float(FILE *file,float f)
{
BO_F_MTOF(&f,1);
fwrite(&f,sizeof(float),1,file);
}
float vfs_read_float(FILE *file)
{
float f;
fread(&f,sizeof(float),1,file);
BO_F_FTOM(&f,1);
return(f);
}
void vfs_skip_float(FILE *file)
{
fseek(file,sizeof(float),SEEK_CUR);
}

void vfs_write_int(FILE *file,int f)
{
BO_I_MTOF(&f,1);
fwrite(&f,sizeof(int),1,file);
}
int vfs_read_int(FILE *file)
{
int f;
fread(&f,sizeof(int),1,file);
BO_I_FTOM(&f,1);
return(f);
}
void vfs_skip_int(FILE *file)
{
fseek(file,sizeof(int),SEEK_CUR);
}
void vfs_write_string(FILE *f,char *s)
{
int l;

l=strlen(s)+1;

vfs_write_int(f,l);

fwrite(s,1,l,f);

}

char * vfs_read_string(FILE *f)
{
int len;
char *s;

len=vfs_read_int(f);


s=(char *) malloc(len);

fread(s,1,len,f);

return(s);
}

void vfs_skip_string(FILE *f)
{
int len;
len=vfs_read_int(f);
fseek(f,len,SEEK_CUR);
}



char *
vfs_getenv (char *s)
{
  char *ret = getenv (s);

  if (!ret)
    {
      fprintf (MOAN, "getenv: failed to find environment var %s\n", s);
      fprintf (MOAN, "getenv: perhaps you ought to set it\n");
    }
  return (ret);

}


void
read_line_from_file (FILE * f, char *b)
{
  char add[2];
  b[0] = 0;
  add[1] = 0;

  while ((add[0] = getc (f)) != 13)
    {
      if (feof (f))
        return;
      strcat (b, add);
    }

  return;
}

void
strip (char *p)
{
  char buf[1024], *s;
  strcpy (buf, p);

  s = buf;
  while (*s)
    {
      if ((!isspace (*s)) && (*s != '\"'))
        *(p++) = *s;

      s++;
    }
  *p = 0;
}



char *
vfs_standardize_altimetry_name (char *path)
{
  char *a;
  a = rindex (path, '/');
  if (!a)
    return (path);
  a++;
  return (a);
}


char *
vfs_standardize_midr_name (char *path)
{
  char *a, *b;

  a = rindex (path, '/');
  if (!a)
    return (path);
  *a = 0;
  b = rindex (path, '/');
  *a = '/';
  if (!b)
    return (path);
  b++;
  return (b);
}


void
commit_suicide ()
{
  fprintf (MOAN, "commit_suicide: doing just that\n");
  kill (getpid (), SIGSEGV);
}

