/* 
 * $Log: vfs.h,v $
 * Revision 1.4  1998/07/31 16:59:48  root
 * makecheckin
 *
 * Revision 1.5  1997/06/23 08:53:13  root
 * makecheckin
 *
 * Revision 1.4  1997/06/15 23:36:54  root
 * makecheckin
 *
 */


#include <mgn_arch.h>

#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <math.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdio.h>

#include "object.h"
#include "latlon.h"
#include "vicar.h"
#include "projection.h"

#define MOAN stderr

#define VFS_CACHE_SIZE 10 		/* How many _volumes_ to
					 * cache */

#define VOL_TYPE_NTAPE  1
#define VOL_TYPE_CDROM  2
#define VOL_TYPE_OTAPE	3
#define VOL_TYPE_MOUNT	4
#define VOL_TYPE_MAX	5

extern char *vfs_vol_type[VOL_TYPE_MAX];

#define REC_TYPE_EOF	    0x0000	/* Not actually written */
#define REC_TYPE_VOLID	    0x7844
#define REC_TYPE_VOLENT     0x7845
#define REC_TYPE_VICARHEAD  0x7846
#define REC_TYPE_PROJECTION 0x7847
	
#define VOL_MAX_LEN 80

typedef struct {
int type;
char id[VOL_MAX_LEN];	 /* Volume id */
} Volid;

typedef struct {
char name[VOL_MAX_LEN];
char path[VOL_MAX_LEN];
} Volent;


#define VFS_Q_PATH 1
#define VFS_Q_CONTAINS 2

typedef struct {
int qtype;
union {
char *path;
struct {
LL ll;
} contains;
} qdata;
} Question;

BEGIN_OBJECT(VFSAnswer)
Volid v;
char *path;
END_OBJECT(VFSAnswer)


extern void vfsanswer_destructor(VFSAnswer);

CREATOR(VFSAnswer)=Obj_DefaultCreator;
DESTRUCTOR(VFSAnswer)=vfsanswer_destructor;

#include "vfs_prototypes.h"


