/* vfs.c */
void vfsanswer_destructor(VFSAnswer a);
VFSAnswer_list vfs_answer_question(Question q, char *type);
int vfs_open(char *path, char *type, int flags);
FILE *vfs_fopen(char *path, char *type, char *mode);
VFSAnswer_list vfs_find_covering(LL ll, char *type);
VFSAnswer_list vfs_find_path(char *path, char *type);
void vfs_print_answerlist(VFSAnswer_list al);
/* cdrom.c */
int vfs_check_attached_cdroms(char *id, char *path, char *ret);
void vfs_scan_cdrom(char *path);
/* util.c */
void vfs_write_float(FILE *file, float f);
float vfs_read_float(FILE *file);
void vfs_skip_float(FILE *file);
void vfs_write_int(FILE *file, int f);
int vfs_read_int(FILE *file);
void vfs_skip_int(FILE *file);
void vfs_write_string(FILE *f, char *s);
char *vfs_read_string(FILE *f);
void vfs_skip_string(FILE *f);
char *vfs_getenv(char *s);
void read_line_from_file(FILE *f, char *b);
void strip(char *p);
char *vfs_standardize_altimetry_name(char *path);
char *vfs_standardize_midr_name(char *path);
void commit_suicide(void);
/* vicar.c */
void vicar_destructor(Vicar v);
int vicar_get_int(Vicar v, char *lbl, int *ret);
int vicar_get_float(Vicar v, char *lbl, float *ret);
char *vicar_get_str(Vicar v, char *lbl);
Vicar open_vicar_by_file(char *path, FILE *f);
Vicar open_vicar(char *path);
void read_vicar(Vicar v);
void vfs_write_vicarheadrec(FILE *f, Vicar v);
int vfs_skip_vicarheadrec(FILE *f);
Vicar vfs_read_vicarheadrec(FILE *f);
/* projection.c */
Projection *create_projection_from_vicar(Vicar v);
int vfs_write_projection(FILE *file, Projection *p);
void vfs_skip_projection(FILE *file);
Projection *vfs_read_projection(FILE *file);
