/*
 * $Log: vicar.c,v $
 * Revision 1.1  1998/07/31 16:59:48  root
 * makecheckin
 *
 * Revision 12.0  1998/07/31 09:58:26  root
 * \#makecheckin
 *
 * Revision 11.0  1998/05/02 23:03:44  root
 * \#makecheckin
 *
 * Revision 10.0  1997/10/22 18:33:55  root
 * \#makecheckin
 *
 * Revision 6.0  1997/07/04  00:32:42  root
 * \#makecheckin
 *
 * Revision 5.0  1997/07/03 15:05:48  root
 * \#makecheckin
 *
 * Revision 4.0  1997/07/01 11:58:59  root
 * \#makecheckin
 *
 * Revision 3.0  1997/06/23 12:51:50  root
 * \#makecheckin
 *
 * Revision 2.0  1997/06/23 09:04:44  root
 * \#makecheckin
 *
 * Revision 1.7  1997/06/18 15:15:32  root
 * \#makecheckin
 *
 * Revision 1.6  1997/06/15 23:47:47  root
 * \#makecheckin
 *
 */

static char rcsid[] = "$Id: vicar.c,v 1.1 1998/07/31 16:59:48 root Exp root $";

#include "vfs.h"


void
vicar_destructor (Vicar v)
{
  if (!v)
    return;

  if (v->file)
    fclose (v->file);

  if (v->name)
    free (v->name);
  if (v->path)
    free (v->path);
  if (v->head)
    free (v->head);

  free (v);

}

int
vicar_get_int (Vicar v, char *lbl, int *ret)
{
  char *s, *f;

  s = malloc (strlen (lbl) + 2);
  strcpy (s, lbl);
  strcat (s, "=");

  f = strstr (v->head, s);

  if (!f)
    {
      free (s);
      return (0);
    }

  f += strlen (s);
  free (s);

  *ret = atoi (f);

  return (1);
}


int
vicar_get_float (Vicar v, char *lbl, float *ret)
{
  char *s, *f;

  s = malloc (strlen (lbl) + 2);
  strcpy (s, lbl);
  strcat (s, "=");

  f = strstr (v->head, s);

  if (!f)
    {
      free (s);
      return (0);
    }

  f += strlen (s);
  free (s);

  *ret = atof (f);

  return (1);
}

char *
vicar_get_str (Vicar v, char *lbl)
{
  char *s, *f;

  s = malloc (strlen (lbl) + 2);
  strcpy (s, lbl);
  strcat (s, "=");

  f = strstr (v->head, s);

  if (!f)
    {
      free (s);
      return (NULL);
    }

  f += strlen (s);
  f++;

  free (s);

  f = strdup (f);
  s = index (f, '\'');
  if (!s)
    return (f);
  *s = 0;
  s = strdup (f);
  free (f);

  return (s);

}




Vicar open_vicar_by_file(char *path,FILE *f)
{
Vicar v;
char *buf;
int lblsize;

  buf = (char *) malloc (100);
  fread (buf, 1, 100, f);

  if (strncmp (buf, "LBLSIZE=", 8) != 0)
    {

      fprintf (MOAN, "vicar: %s is not a vicar file\n", path);

      fclose (f);
      free (buf);
      return (NULL);
    }

  lblsize = atoi (buf + 8);
  if ((lblsize == 0) || (lblsize > 20480))
    {
      fprintf (MOAN, "vicar: %s has preposterous LBLSIZE\n", path);
      free (buf);
      fclose (f);
      return (NULL);
    }


  free (buf);
  rewind (f);


  v = CREATE_OBJ (Vicar);

  v->file = f;
  v->lblsize = lblsize;
  v->head = (char *) malloc (lblsize + 1);

  fread (v->head, 1, lblsize, f);
  v->head[lblsize] = 0;

  v->path = strdup (path);

  v->name = rindex (path, '/');
  if (v->name)
    {
      v->name = strdup (v->name + 1);
    }
  else
    {
      v->name = strdup (path);
    }

  v->nx = v->ny = -1;

  vicar_get_int (v, "NS", &v->nx);
  vicar_get_int (v, "NL", &v->ny);
  return (v);

}

Vicar
open_vicar (char *path)
{
  FILE *f;

  f = vfs_fopen (path, "midr", "r");

  if (!f)
    {
      fprintf (MOAN, "vicar: can't open %s\n", path);
      return (NULL);
    }

return (open_vicar_by_file(path,f));
}


void
read_vicar (Vicar v)
{
  int len;

  if (!v->file)
    {
      v->file = vfs_fopen (v->path, "midr", "r");
    }


  fseek (v->file, v->lblsize, SEEK_SET);

  len = v->nx * v->ny;

  if (!v->data)
    return;

  fread (v->data, v->nx, v->ny, v->file);
  fclose (v->file);
  v->file = NULL;


}


void vfs_write_vicarheadrec(FILE *f,Vicar v)
{


vfs_write_string(f,v->name);
vfs_write_string(f,v->path);


vfs_write_int(f,v->lblsize);

fwrite(v->head,1,v->lblsize,f);

}

vfs_skip_vicarheadrec(FILE *f)
{
int len;

vfs_skip_string(f);
vfs_skip_string(f);

len=vfs_read_int(f);
fseek(f,len,SEEK_CUR);

}

Vicar vfs_read_vicarheadrec(FILE *f)
{
Vicar v;

v=CREATE_OBJ(Vicar);

v->name=vfs_read_string(f);
v->path=vfs_read_string(f);

fread(&v->lblsize,sizeof(v->lblsize),1,f);
v->lblsize=vfs_read_int(f);
v->head=(unsigned char *) malloc(v->lblsize);

fread(v->head,1,v->lblsize,f);

return(v);

}

