/*
 * $Log: getpoint.c,v $
 * Revision 1.1  1998/08/06 16:52:23  root
 * Initial revision
 *
 * Revision 1.1  1997/06/15 23:38:23  root
 * Initial revision
 *
 */

static char rcsid[]="$Id: getpoint.c,v 1.1 1998/08/06 16:52:23 root Exp root $";

#include "mgn.h"
main (int argc, char *argv[])
{
  char buf[1024];
  int alt_fd;
  off_t where;
  int orbit,foot;
  alt_rec alt;

  if (argc!=3) {
	fprintf(stderr,"usage: %s orbit foot\n",argv[0]);
	exit(1);
  }

  orbit=atoi(argv[1]);
  foot=atoi(argv[2]);

  printf("Orbit %d, Foot %d\n",orbit,foot);

  get_alt_filename(orbit,buf);
  
  if ((alt_fd=open(buf,O_RDONLY))<0) {
	perror("open");
	exit(1);
  }

	where=ALT_OFFSET(foot);

     if (where!=lseek (alt_fd, where, SEEK_SET)) {
		perror("lseek");
		exit(1);
	}

      if (read (alt_fd, &alt, sizeof (alt_rec))!=sizeof(alt_rec)) {
		perror("read");
		exit(1);
      }
      BO_F_FTOM (&alt.pos.lat, 2);
      BO_F_FTOM (&alt.rad, 1);
      BO_I_FTOM (&alt.flags, 1);
 
  
	printf("alt.pos = (%.3f,%.3f) alt.rad=%.3f alt.flags=%d\n",
		alt.pos.lat,
		alt.pos.lon,
		alt.rad,
		alt.flags);

  

  exit (0);

}
